1010 '***** PROGRAMA CME: COMPROBACION SECC. RECTANGULAR/T -FLEXION SIMPLE
1020 '***** Autores: F.Morn Cabr - A.Garca Meseguer - P.Jimnez Montoya
1030 '***** Ref: Hormign Armado, Montoya-Meseguer-Morn, Ed.G.Gili, Barna
1040 '***** Lenguaje: GW BASIC para compatibles IBM-PC/XT/AT/PS2 en MS-DOS

1050 DEFINT I-L
1060 DIM CH(7)                                 '*** Coefs. Chebyshev
1070    CH(1) = .0581: CH(2) = .2352: CH(3) = .338: CH(4) = .5
1080    CH(7) = .9419: CH(6) = .7648: CH(5) = .662
1090 FCD = 1750 / 1.5: FYD = 4.1 / 1.1         '*** Resistencias por defecto

1100 CLS : PRINT
1110 T1$ = "              COMPROBACION DE SECCIONES EN FLEXION SIMPLE"
1120 T2$ = "    Seccin Rectang. o T. Mtodo Parbola-Rectngulo. Clculo exacto"
1130 T3$ = "   1=resistencias  2=escuadra  3=recubr.  4=armado  5=momento  6=fin"
1140 T4$ = "                            Momento ltimo: Mu  =###.## mt; gamc =##.##"
1150 PRINT T1$: PRINT: PRINT T2$
1160 COLOR 0, 7: LOCATE 25, 1: PRINT T3$; : COLOR 7, 0

1170 WHILE TAREA% < 6
1180  PRINT
1190  INPUT "                                   Elige opcin = ", TAREA%
1200  IF TAREA% = 1 THEN GOSUB 1260        ' *** Resistencias
1210  IF TAREA% = 2 THEN GOSUB 1290        ' *** Escuadria
1220  IF TAREA% = 3 THEN GOSUB 1370        ' *** Recubrimiento
1230  IF TAREA% = 4 THEN GOSUB 1400        ' *** Armado
1240  IF TAREA% = 5 THEN GOSUB 1520        ' *** Momento
1250 WEND: END

1260 ' *** Resistencias:
1270  INPUT "    Resistencias de calculo : fcd, fyd (kp/cm2) = ", FCD, FYD
1280  FCD = FCD * 10: FYD = FYD / 1000         '*** Paso a unidades de clculo

1290 ' *** Escuadria:
1300  INPUT "             Escuadra de la seccin: b, h (cm) = ", B, H
1310  B = B / 100: H = H / 100                 '*** Paso a metros
1320  SECTE = 0: AC = B * H                    '*** Area sec. hormign m2
1330  IF B > 0 THEN 1380
1340  INPUT "Ancho del nervio y espesor del ala: bw, hf (cm) = ", BW, HF
1350  B = -B: BW = BW / 100: HF = HF / 100     '*** Paso a metros
1360  SECTE = 1: AC = B * HF + BW * (H - HF)

1370 ' *** Recubrimiento:
1380  INPUT "        Recubrimiento mecnico estimado: r (cm) = ", RMEC
1390  RMEC = RMEC / 100                        '*** Paso a metros

1400 '*** Armado:
1410  INPUT "                Armadura compresin: n', '(mm) = ", NP, FIP
1420  INPUT "                Armadura   traccin: n ,  (mm) = ", N, FI
1430  A = 3.141593 * N * FI * FI / 400         '*** Area arm. traccin cm2
1440  AP = 3.141593 * NP * FIP * FIP / 400     '*** Area arm. compres. cm2
1450  IF FYD < 3.41 OR FYD > 3.73 THEN 1470
1460     ROMIN = .0033: GOTO 1500              '*** Cuant. geom. mnima
1470  IF FYD < 4.25 OR FYD > 4.64 THEN 1490
1480     ROMIN = .0028: GOTO 1500
1490     ROMIN = .016 / (FYD + 1.3)
1500  AMIN = 10000 * AC * ROMIN: NPA = NP      '*** Area mn. arm. tracc. cm2
1510  IF A < AMIN THEN PRINT SPACE$(22); "Ojo! No cumple cuanta mnima"

1520 '*** Momento:
1530  INPUT "            Momento flector de clculo: Md (mt) = ", MD
1540  IF MD < 0 THEN 1530
1550  FCMAX = .85 * FCD                        '*** Tens. mx. Diagrama P-R
1560  D = H - RMEC                             '*** canto til
1570  X1 = .628: X2 = .1                       '*** valores tanteo prof.f.n.
1580  X = X1: GOSUB 1700: E1 = NU!             '*** error del 1er tanteo
1590  IF NU! <= 0 THEN 1680                    '*** Arm. tracc. no excesiva
1600    WHILE ABS(NU!) > .0001                 '*** bsqueda posicin f.n.
1610      X = X2: GOSUB 1700: E2 = NU!         '*** error del ultimo tanteo
1620      DX = (X1 - X2) / (E1 - E2) * E2      '*** correccin rgula falsi
1630      IF DX > .2 THEN DX = .2              '*** valor mximo correccin
1640      IF DX < -.2 THEN DX = -.2            '*** valor mnimo
1650      IF DX > X2 THEN DX = X2 - .01        '*** evitar valores negativos
1660      X1 = X2: E1 = E2: X2 = X2 - DX       '*** nuevos valores tanteo
1670    WEND
1680  PRINT USING T4$; MU!, MU!/MD!
1690  RETURN                                   '*** Comn a las 5 subrutinas

1700 '*** Resultante:                          '*** Clculo para una f.n.
1710    IF X < .2593 THEN EPSM = 100 * X / (1 - X) ELSE EPSM = 35
1720    XD = X * D
1730    NC! = 0: MC! = 0
1740    IF SECTE = 0 OR XD <= H1 THEN 1780
1750       U1 = 0: U2 = HF: BU = B: GOSUB 1900
1760       U1 = HF: U2 = XD: BU = BW: GOSUB 1900
1770       GOTO 1790
1780       U1 = 0: U2 = XD: BU = B: GOSUB 1900
1790    S1 = .21 * EPSM * (X - RMEC / D) / X
1800    IF S1 < -FYD THEN S1 = -FYD
1810    IF S1 > FYD THEN S1 = FYD
1820    S2 = .21 * EPSM * (1 - X) / X
1830    IF S2 < -FYD THEN S2 = -FYD
1840    IF S2 > FYD THEN S2 = FYD
1850    NS! = AP * S1 - A * S2
1860    MS! = AP * S1 * (D - RMEC)
1870    NU! = NC! + NS!
1880    MU! = MC! + MS!
1890    RETURN

1900 '*** Integra:                             '*** Esfzos en secc. hormign
1910    DU = U2 - U1
1920    FOR I = 1 TO 7
1930      U = U1 + DU * CH(I)
1940      EPSC = EPSM * (X - U / D) / X
1950      IF EPSC > 20 THEN SIGC = FCMAX: GOTO 1970
1960         F = 1 - EPSC / 20: SIGC = FCMAX * (1 - F * F)
1970      DN = SIGC * BU * DU / 7
1980     NC! = NC! + DN
1990     MC! = MC! + DN * (D - U)
2000   NEXT I
2010   RETURN
