1010 '***** PROGRAMA CMNA: COMPROBACION SECC. CIRCULAR/ANULAR A FLEXOCOMPR
1020 '***** Autores: F.Morn Cabr - A.Garca Meseguer - P.Jimnez Montoya
1030 '***** Ref: Hormign Armado, Montoya-Meseguer-Morn, Ed.G.Gili, Barna
1040 '***** Lenguaje: GW BASIC para compatibles IBM-PC/XT/AT/PS2 en MS-DOS

1050 DEFINT I-J, N: DIM N(9), Y(9), K(7)
1060 K(1) = .0581: K(2) = .2352: K(3) = .338: K(4) = .5  '*** Coefs.Chebyshev
1070 K(7) = .9419: K(6) = .7648: K(5) = .662: CLS
1080 FCD = 1750 * .9 / 1.5: FYD = 4.1 / 1.1     '*** Resistencias por defecto

1090 CLS : PRINT
1100 T1$ = "           COMPROBACION DE SOPORTES CORTOS A FLEXOCOMPRESION"
1110 T2$ = "   Seccin Circular/Anular. Mtodo Parbola-Rectngulo. Clculo exacto"
1120 T3$ = "1=resistencias  2=seccin   3=recubr.  4=armado   5=solicitac.  6=fin"
1130 T4$ = "            Axil ltimo: Nu =###.## t;  gamc =##.##"
1140 PRINT T1$: PRINT: PRINT T2$
1150 COLOR 0, 7: LOCATE 25, 1: PRINT T3$; : COLOR 7, 0

1160 WHILE TAREA% < 6
1170  PRINT
1180  INPUT "                                   Elige opcin = ", TAREA%
1190  IF TAREA% = 1 THEN GOSUB 1250        ' *** Resistencias
1200  IF TAREA% = 2 THEN GOSUB 1280        ' *** Escuadria
1210  IF TAREA% = 3 THEN GOSUB 1310        ' *** Recubrimiento
1220  IF TAREA% = 4 THEN GOSUB 1340        ' *** Armado
1230  IF TAREA% = 5 THEN GOSUB 1520        ' *** Solicitacion
1240 WEND: END

1250 ' *** Resistencias:
1260  INPUT "    Resistencias de calculo : fcd, fyd (kp/cm2) = ", FCD, FYD
1270  FCD = FCD * 10: FYD = FYD / 1000       '*** Paso a unidades de clculo

1280 ' *** Escuadria:
1290  INPUT "    Dimetro y espesor de la seccin: h, e (cm) = ", H, ESP
1300  H = H / 100: ESP = ESP / 100           '*** Paso a metros

1310 ' *** Recubrimiento:
1320  INPUT "        Recubrimiento mecnico estimado: r (cm) = ", C
1330  C = C / 100                            '*** Paso a metros

1340 ' *** Armado:
1350  INPUT "Nm. barras (mn=6; mx=18), dime.: Nb,  (mm) = ", NB, DIA
1360  IF NB < 6 OR NB > 18 THEN 1350
1370  HI = H - 2 * ESP: H2 = H / 2               '*** Dim.hueco y radio
1380  NB2 = NB \ 2                               '*** Nm. capas de barras
1390  FI = 3.141593 / NB2                        '*** Diferencia ang. capas
1400  R = H2 - C: FI0 = FI / 2                   '*** Radio armaduras
1410  FOR I = 1 TO NB2
1420      N(I) = 2                               '*** Nm. barras/capa
1430      Y(I) = R * COS(FI0)                    '*** Altura capa
1440      FI0 = FI0 + FI
1450  NEXT I
1460  D = H - C: AC = (H - ESP) * ESP * 3.141593 '*** Canto til y rea sec.
1470  EMIN = H / 20                              '*** Excentricidad mnima
1480  IF EMIN < .02 THEN EMIN = .02
1490  AMIN = 40 * AC / NB                        '*** rea mnima / barra cm2
1500  ABAR = 3.141593 * DIA * DIA / 400          '*** rea real de cada barra
1510  IF ABAR < AMIN THEN PRINT SPACE$(20); "Ojo! No cumple cuanta mnima"

1520 ' *** Solicitacion:
1530  INPUT "Solicitacin actuante de clculo: Md, Nd (mt,t) = ", MD, ND!
1540  IF MD < 0 THEN MD = -MD
1550  IF ND! = 0 THEN ND! = -1                   '*** Ojo no valen axiles de
1560  IF ABS(ND!) < 1 THEN ND! = SGN(ND!)        '*** pequeo valor absoluto
1570  IF MD < EMIN * ND! THEN MD = EMIN * ND!
1580  EXC = MD / ND!: KEX = 0
1590  IF EXC > H / 2 THEN EXC = 1 / EXC: KEX = 1

1600  X1 = .6 * H: X2 = .9 * H
1610  X3 = X1: GOSUB 1720: ER1 = ER0
1620  WHILE ABS(ER0) > .0001                    '*** Tanteos mtodo de la cuerda
1630      X3 = X2: GOSUB 1720: ER2 = ER0
1640      DX = (X1 - X2) / (ER1 - ER2) * ER2    '*** Correccin
1650      IF ABS(DX) > .2 * H THEN DX = .2 * H * SGN(DX)
1660     'IF dx * er2 > 0 THEN dx = -dx
1670      IF DX > X2 THEN DX = X2 - .01
1680      X1 = X2: ER1 = ER2: X2 = X2 - DX
1690  WEND
1700  PRINT USING T4$; NU!, NU!/ND!
1710  RETURN                                    '*** Comn para las 5 subrutinas

1720 '*** Resultante:                   '*** Subr.Pral.: Clculo para una f.n.
1730  X = X3 / D                                 '*** prof. f.n. relativa
1740  IF X < .2593 THEN EPSC = 100 * X / (1 - X): GOTO 1770
1750  IF X3 < H THEN EPSC = 35: GOTO 1770        '*** epsc = def. fibra sup.
1760  X = X3 / H: EPSC = 20 * X / (X - 3 / 7)
1770  DEPS = EPSC / X3: X4 = X3                  '*** deps = gradiente deform.

1780  IF X4 > H THEN X4 = H                      '*** Esfzos.sec.circular ext.
1790  FAC = X4 / 7 * .85 * FCD
1800  NC! = 0: MC = 0
1810  FOR I = 1 TO 7
1820    U = K(I) * X4                            '*** Prof. fibra
1830    B = 2 * SQR((H - U) * U)                 '*** Ancho fibra
1840    EPS = EPSC - U * DEPS                    '*** Deformacin fibra
1850    IF EPS > 20 THEN SGR = 1 ELSE S = 1 - EPS / 20: SGR = 1 - S * S
1860    SGR = SGR * B                            '*** Tensin y axil fibra
1870    NC! = NC! + SGR
1880    MC = MC + SGR * (H2 - U)
1890  NEXT I
1900  NC! = NC! * FAC
1910  MC = MC * FAC

1920  X4 = X3 - ESP: IF X4 > HI THEN X4 = HI     '*** Esfzos.sec.hueca inter.
1930  IF X4 <= 0 THEN 2070
1940    FAC = X4 / 7 * .85 * FCD
1950    NCI! = 0: MCI = 0
1960    FOR I = 1 TO 7
1970      UI = K(I) * X4: U = ESP + UI
1980      B = 2 * SQR((HI - UI) * UI)
1990      EPS = EPSC - U * DEPS
2000      IF EPS > 20 THEN SGR = 1 ELSE S = 1 - EPS / 20: SGR = 1 - S * S
2010      SGR = SGR * B
2020      NCI! = NCI! + SGR
2030      MCI = MCI + SGR * (H2 - U)
2040    NEXT I
2050    NC! = NC! - NCI! * FAC
2060    MC = MC - MCI * FAC

2070 NS! = 0: MS = 0: S = .21 * EPSC             '*** Esfzos armaduras Abar=1
2080 FOR I = 1 TO NB2
2090    SGR = S * (X3 + Y(I) - H2) / X3          '*** Tensin en cada capa
2100    IF SGR < -FYD THEN SGR = -FYD
2110    IF SGR > FYD THEN SGR = FYD
2120    SGR = SGR * N(I): NS! = NS! + SGR
2130    MS = MS + SGR * Y(I)
2140  NEXT I

2150  NU! = NC! + ABAR * NS!
2160  MU = MC + ABAR * MS
2170  IF KEX = 0 THEN EXU = MU / NU! ELSE EXU = NU! / MU
2180  ER0 = EXU - EXC                           '*** Error de excentricidades
2190  RETURN
