1010 '***** PROGRAMA DM2G: DIMENSIONAM. SECC.POLIGONAL FLEXOCOMPR. ESVIADA
1020 '***** Autores: F.Morn Cabr - A.Garca Meseguer - P.Jimnez Montoya
1030 '***** Ref: Hormign Armado, Montoya-Meseguer-Morn, Ed.G.Gili, Barna
1040 '***** Lenguaje: GW BASIC para compatibles IBM-PC/XT/AT/PS2 en MS-DOS

1050 DEFINT I-J, N
1060 DIM N(10), X(11), Y(11), XS(11), YS(11), XP(11), YP(11), XSP(11), DEL(5)
1070 FCD = 1750 * .9 / 1.5: FYD = 4.1 / 1.1: CLS : PRINT  '*** Resist. defecto

1080 PRINT "        DIMENSIONAMIENTO DE SOPORTES EN FLEXOCOMPRESION ESVIADA"
1090 T$ = "   Seccin poligonal. Mtodo Parbola-Rectngulo. Clculo riguroso"
1100 S$ = "                Capacidad mecnica por barra U =###.## t;   = ##.## mm"
1110 PRINT : PRINT T$: FCD = .85 * FCD
1120 T$ = "1=resistencias  2=def.secc.  3=recubr.  4=Cd. Armado  5=solicit.  6=fin"
1130 COLOR 0, 7: LOCATE 25, 1: PRINT T$; : COLOR 7, 0: PRINT

1140 WHILE TAREA% < 6
1150    INPUT "                                  Elige opcin = ", TAREA%
1160    IF TAREA% = 1 THEN GOSUB 1220              '*** Resistencias
1170    IF TAREA% = 2 THEN GOSUB 1250              '*** Def.Seccion
1180    IF TAREA% = 3 THEN GOSUB 1460              '*** Recubrimiento
1190    IF TAREA% = 4 THEN GOSUB 1480              '*** Cod.Armado
1200    IF TAREA% = 5 THEN GOSUB 1710              '*** Solicitacion
1210 WEND: END

1220 '*** Resistencias:
1230    INPUT "   Resistencias de clculo:  fcd, fyd (kp/cm2) = ", FCD, FYD
1240    FCD = 8.5 * FCD: FYD = FYD / 1000        '*** Paso unidades de calculo

1250 '*** Def.Seccion:
1260    INPUT "Definicin contorno seccin. Nm. vrtices  nv = ", NV
1270    BETMIN = -90: BETMAX = 270
1280    FOR I = 1 TO NV
1290      PRINT "         Coordenadas del vrtice"; I;
1300      INPUT ": X, Y (cm) = ", X(I), Y(I)
1310      X(I) = X(I) / 100: Y(I) = Y(I) / 100
1320    NEXT I
1330    NV1 = NV + 1: X(NV1) = X(1): Y(NV1) = Y(1)  '*** Cierre poligonal
1340    XMIN = 1000: YMIN = 1000: XMAX = -1000: YMAX = -1000: AC = 0
1350    FOR I = 1 TO NV
1360      AC = AC + (Y(I + 1) + Y(I)) * (X(I + 1) - X(I)) / 2  '*** Area hn
1370      IF X(I) < XMIN THEN XMIN = X(I)
1380      IF X(I) > XMAX THEN XMAX = X(I)
1390      IF Y(I) < YMIN THEN YMIN = Y(I)
1400      IF Y(I) > YMAX THEN YMAX = Y(I)
1410    NEXT I
1420    HX = XMAX - XMIN: EXMIN = HX / 20
1430    IF EXMIN < .02 THEN EXMIN = .02                       '*** Excent.
1440    HY = YMAX - YMIN: EYMIN = HY / 20
1450    IF EYMIN < .02 THEN EYMIN = .02                       '*** mnimas

1460 '*** Recubrimiento:
1470    INPUT "      Recubrimiento mecnico estimado:  r (cm) = ", R: R = R / 100

1480 '*** Cod.Armado:
1490    INPUT "           Cdigo de Armado C A: ( nv cifras ) = ", CA$: NBAR = 0
1500    FOR I = 1 TO NV
1510       N(I) = VAL(LEFT$(CA$, 1))
1520       CA$ = RIGHT$(CA$, NV - I)
1530    NEXT I
1540    FOR I = 1 TO NV
1550      NBAR = NBAR + N(I)
1560      IF I = 1 THEN NO = NV: NE = 1 ELSE NO = I - 1: NE = I
1570      GOSUB 3190                             '*** Clculo coord. barras
1580      DYA = DY: DXA = DX: DZA = DZ
1590      NO = I: NE = I + 1
1600      GOSUB 3190
1610      DD = DY * DXA - DYA * DX
1620      XS(I) = (DZ * DXA - DZA * DX) / DD     '*** Coord. barra esquina
1630      YS(I) = (DY * DZA - DYA * DZ) / DD     '*** en el vrtice i
1640    NEXT I
1650    XS(NV1) = XS(1): YS(NV1) = YS(1)         '*** Cierre poligonal
1660    NBAR = NBAR - NV                         '*** Nmero de barras
1670    A = -FCD / 400: B = FCD / 10
1680    RAD = 180 / 3.14159265#
1690    DBETMAX = (BETMAX - BETMIN) / 10
1700    UMIN = 40 * FYD * AC / NBAR              '*** Capac.mecn.barra mnima

1710 '*** Solicitacion:
1720    INPUT "Solic. act. de clculo: Mxd(hy), Myd(mt), Nd(t)= ", MXD, MYD, ND!
1730    T = TIMER: IF ND! < 1 THEN ND! = 1

1740    EX = MYD / ND!: EY = MXD / ND!           '*** Excentricidades
1750    FI = 90: IF EY < 0 THEN FI = -FI
1760    IF ABS(EX) >= EXMIN OR ABS(EY) >= EYMIN THEN 1820
1770      IF HX >= HY THEN 1800
1780        EX = EXMIN * SGN(EX): IF EX = 0 THEN EX = EXMIN
1790        MYD = EX * ND!: MXD = 0: EY = 0: GOTO 1820
1800      EY = EYMIN * SGN(EY): IF EY = 0 THEN EY = EYMIN
1810      MXD = EY * ND!: MYD = 0: EX = 0
1820    IF EX = 0 THEN 1850
1830      FI = RAD * ATN(EY / EX * HX / HY)
1840      IF EX < 0 THEN FI = FI + 180

1850    NCICL = 1: BETA = FI: XI = .7: GOSUB 2100    '*** Valores iniciales
1860    WHILE ABS(EN) > .0001 OR ABS(EM) > .0001
1870      XI1 = XI: EN1 = EN: XI = XI1 + .01         '*** Nuevo valor de xi
1880      WHILE ABS(EN) > .0001
1890        GOSUB 2100                               '*** Subr. principal
1895        IF EN1 = EN THEN PRINT SPACE$(45); "No converge": PRINT: RETURN
1900        DXI = (XI1 - XI) / (EN1 - EN) * EN       '*** Correccin de xi
1910        IF ABS(DXI) > .2 THEN DXI = .2 * SGN(DXI)'*** Valor mx.correccin
1920        IF DXI * EN > 0 THEN DXI = -DXI          '*** Cambio de sentido
1930        XI1 = XI: EN1 = EN: XI = XI - DXI        '*** Nuevos valores
1940        IF XI > 2 THEN XI = 2                    '*** Valores extremos
1950        IF XI < 0 THEN XI = .01
1955        IF NCICL > 100 THEN PRINT SPACE$(45); "No converge": PRINT: RETURN
1960      WEND                                       '*** Nuevo tanteo de xi
1970      BETA1 = BETA: EM1 = EM: BETA = BETA1 + 1   '*** Nuevo valor de beta
1980      WHILE ABS(EM) > .0001
1990        GOSUB 2100                               '*** Subr. principal
1995        IF EM1 = EM THEN PRINT SPACE$(45); "No converge": PRINT: RETURN
2000        DBETA = (BETA1 - BETA) / (EM1 - EM) * EM '*** Correccin de beta
2010        IF ABS(DBETA) > DBETMAX THEN DBETA = DBETMAX * SGN(DBETA) '*V.mx.
2020        BETA1 = BETA: EM1 = EM: BETA = BETA - DBETA'*** Nuevos valores
2030        IF BETA > BETMAX THEN BETA = BETMAX      '*** Valores extremos
2040        IF BETA < BETMIN THEN BETA = BETMIN
2045        IF NCICL > 100 THEN PRINT SPACE$(45); "No converge": PRINT: RETURN
2050      WEND
2060    WEND

2070    U = ABAR * FYD: IF U < UMIN THEN U = UMIN    '*** Capac.mecn.por barra
2080    PRINT USING S$; U, 20 * SQR(U / FYD / 3.1416): PRINT
2090    RETURN

2100 '*** Resultante:                  '*** Subr. Pral.: Clculo para una f.n.
2110   XMIN = 1000: XSMIN = 1000: XMAX = -1000
2120   S = SIN(BETA / RAD): C = COS(BETA / RAD)   '*** sen y cos de beta
2130   IF ABS(C) < .0001 THEN C = 0: S = SGN(S)
2140   FOR I = 1 TO NV1
2150     XP(I) = X(I) * C + Y(I) *    S           '*** Coord. en ejes girados
2160     YP(I) = -X(I) * S + Y(I) * C
2170     IF XP(I) < XMIN THEN XMIN = XP(I)       '*** xmin = vrt.menos compr.
2180     IF XP(I) > XMAX THEN XMAX = XP(I)       '*** xmax = vrt. ms compr.
2190   NEXT I
2200   FOR I = 1 TO NV
2210     XSP(I) = XS(I) * C + YS(I) * S         '*** Abscisas giradas de barr.
2220     IF XSP(I) < XSMIN THEN XSMIN = XSP(I)  '*** xsmin = barra menos compr.
2230   NEXT I
2240   XSP(NV1) = XSP(1)
2250   D = (XMAX - XSMIN) / (XMAX - XMIN)       '*** Canto til relat. oblicuo

2260   IF XI > 0 THEN 2290
2270     EPSC = 100 * XI                        '*** Dominio 1
2280     EPSS = -100: GOTO 2380
2290   IF XI > .2593 * D THEN 2320
2300     EPSC = 100 * XI / (D - XI)             '*** Dominio 2
2310     EPSS = -100: GOTO 2380
2320   IF XI > 1 THEN 2350
2330     EPSC = 35                              '*** Dominios 3 y 4
2340     EPSS = 35 * (XI - D) / XI: GOTO 2380
2350     EPSC = 50 - 15 * XI                    '*** Dominio 5
2360     EPS = 35 * (1 - D)
2370     EPSS = EPS + (XI - 1) * (20 - EPS)

2380   NC! = 0: MXC = 0: MYC = 0                '*** Resultantes hormign
2390   NS! = 0: MXS = 0: MYS = 0                '*** Resultantes armaduras
2400   AE = (EPSC - EPSS) / (XMAX - XSMIN)
2410   BE = EPSC - AE * XMAX
2420   X0 = -BE / AE: X20 = (20 - BE) / AE      '*** Abscisas para eps=0 y 20
2430   FOR I = 1 TO NV
2440     X1 = XP(I): X2 = XP(I + 1): SIGNO = 1: YO = YP(I)
2450     IF X1 = X2 THEN 2610
2460       IF X1 < X2 THEN 2490
2470         X1 = XP(I + 1): X2 = XP(I)
2480         SIGNO = -1: YO = YP(I + 1)
2490       IF X2 <= X0 THEN 2610
2500         AY = SIGNO * (YP(I + 1) - YP(I)) / (X2 - X1)
2510         BY = YO - AY * X1
2520         IF X1 <= X0 THEN X1 = X0
2530         IF X2 > X20 THEN 2560
2540           XP1 = X1: XP2 = X2: N5 = 1: GOSUB 2940
2550           GOTO 2610
2560         IF X1 >= X20 THEN 2600
2570           XP1 = X1: XP2 = X20: N5 = 1: GOSUB 2940
2580           XP1 = X20: XP2 = X2: N5 = 0: GOSUB 2940
2590           GOTO 2610
2600           XP1 = X1: XP2 = X2: N5 = 0: GOSUB 2940
2610   NEXT I
2620   EXC = MYC / NC!: EYC = MXC / NC!         '*** Excentricidades giradas
2630   MXC = NC! * (EXC * S + EYC * C)
2640   MYC = NC! * (EXC * C - EYC * S)          '*** Esfzos en ejes grales

2650   FOR I = 1 TO NV
2660     X = XS(I): Y = YS(I): XP = XSP(I): N = N(I) - 1
2670     DX = 0: DY = 0: DXP = 0
2680     IF N = 1 THEN 2710
2690       DX = (XS(I + 1) - X) / N
2700       DY = (YS(I + 1) - Y) / N: DXP = (XSP(I + 1) - XP) / N
2710     FOR J = 1 TO N
2720       EPS = AE * XP + BE: SIG = .21 * EPS
2730       IF SIG < -FYD THEN SIG = -FYD
2740       IF SIG > FYD THEN SIG = FYD
2750       NS! = NS! + SIG: MXS = MXS + SIG * Y: MYS = MYS + SIG * X
2760       X = X + DX: Y = Y + DY: XP = XP + DXP
2770     NEXT J
2780   NEXT I

2790   IF ABS(NS!) <= .1 THEN 2810
2800      ABAR = (ND! - NC!) / NS!: GOTO 2840
2810   IF ABS(MXS) <= .1 THEN 2830
2820      ABAR = (MXD - MXC) / MXS: GOTO 2840
2830      ABAR = (MYD - MYC) / MYS
2840   NF! = ND! - NC!: MXF = MXD - MXC
2850   MYF = MYD - MYC                          '*** Esf. diferencia para acero

2860   IF ABS(MYD) >= ABS(MXD) THEN 2900
2870     EN = (NF! - MXF * NS! / MXS) / ND!     '*** Error en axil
2880     EM = (MXF * MYS / MXS - MYF) / MXD     '*** Error en momento
2890     GOTO 2920
2900     EN = (NF! - MYF * NS! / MYS) / ND!
2910     EM = (MXF - MYF * MXS / MYS) / MYD
2920   IF ABS(ABS(EM) - 3.14159265#) < .001 THEN EM = 0
2925   NCICL = NCICL + 1
2930   RETURN

2940 '*** Trapecio:                             '** Subr. resultante tensiones
2950   Z1 = XP1: Z2 = XP2                       '** de hormign en un trapecio
2960   FOR J = 1 TO 5
2970     DEL(J) = (Z2 - Z1) / J
2980     Z1 = Z1 * XP1: Z2 = Z2 * XP2
2990   NEXT J
3000   IF N5 <> 0 THEN 3030
3010      ASIG = 0: BSIG = 0: CSIG = FCD
3020      GOTO 3060
3030      ASIG = A * AE * AE
3040      BSIG = 2 * A * AE * BE + B * AE
3050      CSIG = A * BE * BE + B * BE
3060   F4 = ASIG * AY
3070   F3 = BSIG * AY + ASIG * BY
3080   F2 = CSIG * AY + BSIG * BY
3090   F1 = CSIG * BY
3100   G5 = F4 * AY
3110   G4 = F3 * AY + ASIG * AY * BY
3120   G3 = F2 * AY + BSIG * AY * BY + ASIG * BY * BY
3130   G2 = F1 * AY + CSIG * AY * BY + BSIG * BY * BY
3140   G1 = CSIG * BY * BY
3150   NC! = NC! + SIGNO * (F4 * DEL(4) + F3 * DEL(3) + F2 * DEL(2) + F1 * DEL(1))
3160   MXC = MXC + SIGNO * (G5 * DEL(5) + G4 * DEL(4) + G3 * DEL(3) + G2 * DEL(2) + G1 * DEL(1)) / 2
3170   MYC = MYC + SIGNO * (F4 * DEL(5) + F3 * DEL(4) + F2 * DEL(3) + F1 * DEL(2))
3180   RETURN

3190 '*** Coord.Bar.Esq:                     '** Clculo coord. barras esquina
3200   XO = X(NO): YO = Y(NO)
3210   XE = X(NE): YE = Y(NE)
3220   DY = YE - YO: DX = XO - XE
3230   DZ = DY * XO + DX * YO + R * SQR(DX * DX + DY * DY)
3240   RETURN
