1010 '***** PROGRAMA CM2G: COMPROBACION SECC.POLIGONAL FLEXOCOMPR. ESVIADA
1020 '***** Autores: F.Morn Cabr - A.Garca Meseguer - P.Jimnez Montoya
1030 '***** Ref: Hormign Armado, Montoya-Meseguer-Morn, Ed.G.Gili, Barna
1040 '***** Lenguaje: GW BASIC para compatibles IBM-PC/XT/AT/PS2 en MS-DOS

1050 DEFINT I-J, N
1060 DIM N(10), X(11), Y(11), XS(11), YS(11), XP(11), YP(11), XSP(11), DEL(5)
1070 DIM XIN(8), YIN(8), XFI(8), YFI(8), A(8), XIG(8), XFG(8)
1080 FCD = 1750 * .9 / 1.5: FYD = 4.1 / 1.1: CLS : PRINT  '*** Resist. defecto

1090 PRINT "          COMPROBACION DE SOPORTES EN FLEXOCOMPRESION ESVIADA"
1100 T$ = "   Seccin poligonal. Mtodo Parbola-Rectngulo. Clculo riguroso"
1110 S$ = "                      Esfuerzo axil ltimo: Nu =###.## t;  gamc =##.##"
1120 PRINT : PRINT T$: FCD = .85 * FCD
1130 T$ = "1=resistencias    2=def.secc.    4=armado    5=solicit.    6=fin"
1140 COLOR 0, 7: LOCATE 25, 1: PRINT T$; : COLOR 7, 0: PRINT

1150 WHILE TAREA% < 6
1160    INPUT "                                  Elige opcin = ", TAREA%
1170    IF TAREA% = 1 THEN GOSUB 1230              '*** Resistencias
1180    IF TAREA% = 2 THEN GOSUB 1260              '*** Def.Seccion
1190    IF TAREA% = 3 THEN GOSUB 1470              '*** Armado
1200    IF TAREA% = 4 THEN GOSUB 1470              '*** Armado
1210    IF TAREA% = 5 THEN GOSUB 1620              '*** Solicitacion
1220 WEND: END

1230 '*** Resistencias:
1240    INPUT "   Resistencias de clculo:  fcd, fyd (kp/cm2) = ", FCD, FYD
1250    FCD = 8.5 * FCD: FYD = FYD / 1000        '*** Paso unidades de calculo

1260 '*** Def.Seccion:
1270    INPUT "Definicin contorno seccin. Nm. vrtices  nv = ", NV
1280    BETMIN = -90: BETMAX = 270
1290    FOR I = 1 TO NV
1300      PRINT "         Coordenadas del vrtice"; I;
1310      INPUT ": X, Y (cm) = ", X(I), Y(I)
1320      X(I) = X(I) / 100: Y(I) = Y(I) / 100
1330    NEXT I
1340    NV1 = NV + 1: X(NV1) = X(1): Y(NV1) = Y(1)  '*** Cierre poligonal
1350    XMIN = 1000: YMIN = 1000: XMAX = -1000: YMAX = -1000: AC = 0
1360    FOR I = 1 TO NV
1370      AC = AC + (Y(I + 1) + Y(I)) * (X(I + 1) - X(I)) / 2  '*** Area hn
1380      IF X(I) < XMIN THEN XMIN = X(I)
1390      IF X(I) > XMAX THEN XMAX = X(I)
1400      IF Y(I) < YMIN THEN YMIN = Y(I)
1410      IF Y(I) > YMAX THEN YMAX = Y(I)
1420    NEXT I
1430    HX = XMAX - XMIN: EXMIN = HX / 20
1440    IF EXMIN < .02 THEN EXMIN = .02                       '*** Excent.
1450    HY = YMAX - YMIN: EYMIN = HY / 20
1460    IF EYMIN < .02 THEN EYMIN = .02                       '*** mnimas

1470 '*** Armado:
1480    INPUT "Definicin del armado:  Nm. de armaduras:  na = ", NARM: ASTOT = 0
1490    FOR I = 1 TO NARM
1500      PRINT "Arm."; I;
1510      INPUT "Coord.inicial y final:  Xi,Yi,Xf,Yf(cm) = ", XIN(I), YIN(I), XFI(I), YFI(I)
1520      INPUT "Nm.y dim. de barras de la armad.: nb,  (mm) = ", N(I), DIA
1530      XIN(I) = XIN(I) / 100: YIN(I) = YIN(I) / 100
1540      XFI(I) = XFI(I) / 100: YFI(I) = YFI(I) / 100
1550      A(I) = DIA * DIA * 3.141593 / 400
1560      ASTOT = ASTOT + A(I) * N(I)
1570    NEXT I
1580    IF ASTOT / AC < 40 THEN PRINT SPACE$(20); "No cumple cuanta mnima"
1590    A = -FCD / 400: B = FCD / 10
1600    RAD = 180 / 3.141593
1610    DBETMAX = (BETMAX - BETMIN) / 10

1620 '*** Solicitacion:
1630    INPUT "Solic. act. de clculo: Mxd(hy), Myd(mt), Nd(t)= ", MXD, MYD, ND!
1640    IF ND! < 1 THEN ND! = 1
1650    EX = MYD / ND!: EY = MXD / ND!           '*** Excentricidades
1660    FI = 90: IF EY < 0 THEN FI = -FI
1670    IF ABS(EX) >= EXMIN OR ABS(EY) >= EYMIN THEN 1730
1680      IF HX >= HY THEN 1710
1690        EX = EXMIN * SGN(EX): IF EX = 0 THEN EX = EXMIN
1700        MYD = EX * ND!: MXD = 0: EY = 0: GOTO 1730
1710      EY = EYMIN * SGN(EY): IF EY = 0 THEN EY = EYMIN
1720      MXD = EY * ND!: MYD = 0: EX = 0

1730    IF EX = 0 THEN 1760
1740      FI = RAD * ATN(EY / EX * HX / HY)      '*** Angulo de la resultante
1750      IF EX < 0 THEN FI = FI + 180
1760    RO = SQR(EX * EX + EY * EY)              '*** Dist. origen (exc. total)
1770    IF RO > SQR(HX * HX + HY * HY) / 2 THEN RO = 1 / RO: KEX = 1 ELSE KEX = 0

1780    BET = FI: XI = .7: GOSUB 2020            '*** Valores iniciales
1790    WHILE ABS(ERRRO) > .001 * RO OR ABS(ERRAN) > .1
1800      XI1 = XI: E5 = ERRRO: XI = XI1 + .01   '*** Nuevo valor de xi
1810      WHILE ABS(ERRRO) > .001 * RO
1820        GOSUB 2020                           '*** Subrutina principal
1830        DXI = (XI1 - XI) / (E5 - ERRRO) * ERRRO    '*** Correccin de xi
1840        IF ABS(DXI) > .2 THEN DXI = .2 * SGN(DXI)'*** Valor mx. correccin
1850        'IF dxi * errRo > 0 THEN dxi = -dxi  '*** Cambio de sentido
1860        XI1 = XI: E5 = ERRRO: XI = XI - DXI  '*** Nuevos valores
1870        IF XI > 2 THEN XI = 2                '*** Valores extremos
1880        IF XI < 0 THEN XI = .01
1890      WEND                                   '*** Nuevo tanteo de xi
1900      BET1 = BET: E6 = ERRAN: BET = BET1 + 1 '*** Nuevo valor de beta
1910     WHILE ABS(ERRAN) > .1
1920       GOSUB 2020                            '*** Subrutina principal
1930       DBET = (BET1 - BET) / (E6 - ERRAN) * ERRAN '*** Correccin de beta
1940       IF ABS(DBET) > DBETMAX THEN DBET = DBETMAX * SGN(DBET)'*** mx. corr.
1950       BET1 = BET: E6 = ERRAN: BET = BET - DBET  '*** Nuevos valores
1960       IF BET > BETMAX THEN BET = BETMAX         '*** Valores extremos
1970       IF BET < BETMIN THEN BET = BETMIN
1980     WEND                                        '*** Nuevo tanteo de beta
1990   WEND
2000   PRINT USING S$; NU!, NU! / ND!: PRINT
2010   RETURN                                    '*** Comn a las 5 subrut.

2020 '*** Resultante:                  '*** Subr. Pral.: Clculo para una f.n.
2030   XMIN = 1000: XSMIN = 1000: XMAX = -1000
2040   S = SIN(BET / RAD): C = COS(BET / RAD)    '*** sen y cos de beta
2050   IF ABS(C) < .0001 THEN C = 0: S = SGN(S)
2060   FOR I = 1 TO NV1
2070     XP(I) = X(I) * C + Y(I) * S             '*** Coord. en ejes girados
2080     YP(I) = -X(I) * S + Y(I) * C
2090     IF XP(I) < XMIN THEN XMIN = XP(I)       '*** xmin = vrt.menos compr.
2100     IF XP(I) > XMAX THEN XMAX = XP(I)       '*** xmax = vrt. ms compr.
2110   NEXT I
2120   FOR I = 1 TO NARM
2130     XIG(I) = XIN(I) * C + YIN(I) * S        '*** Abscisa girada 1 barra
2140     XFG(I) = XFI(I) * C + YFI(I) * S        '*** Abscisa girada ltima b.
2150     IF XIG(I) < XSMIN THEN XSMIN = XIG(I)
2160     IF XFG(I) < XSMIN THEN XSMIN = XFG(I)
2170   NEXT I
2180   D = (XMAX - XSMIN) / (XMAX - XMIN)        '*** Canto til relat.oblicuo

2190   IF XI > 0 THEN 2220
2200     EPSC = 100 * XI                         '*** Dominio 1
2210     EPSS = -100: GOTO 2310
2220   IF XI > .2593 * D THEN 2250
2230     EPSC = 100 * XI / (D - XI)              '*** Dominio 2
2240     EPSS = -100: GOTO 2310
2250   IF XI > 1 THEN 2280
2260     EPSC = 35                               '*** Dominios 3 y 4
2270     EPSS = 35 * (XI - D) / XI: GOTO 2310
2280     EPSC = 50 - 15 * XI                     '*** Dominio 5
2290     EPS = 35 * (1 - D)
2300     EPSS = EPS + (XI - 1) * (20 - EPS)

2310   NC! = 0: MXC = 0: MYC = 0                 '*** Resultantes hormign
2320   NS! = 0: MXS = 0: MYS = 0                 '*** Resultantes armaduras
2330   AE = (EPSC - EPSS) / (XMAX - XSMIN)
2340   BE = EPSC - AE * XMAX
2350   X0 = -BE / AE: X20 = (20 - BE) / AE       '*** Abscisas para eps=0 y 20
2360   FOR I = 1 TO NV
2370     X1 = XP(I): X2 = XP(I + 1): SIGNO = 1: YO = YP(I)
2380     IF X1 = X2 THEN 2540
2390       IF X1 < X2 THEN 2420
2400         X1 = XP(I + 1): X2 = XP(I)
2410         SIGNO = -1: YO = YP(I + 1)
2420       IF X2 <= X0 THEN 2540
2430         AY = SIGNO * (YP(I + 1) - YP(I)) / (X2 - X1)
2440         BY = YO - AY * X1
2450         IF X1 <= X0 THEN X1 = X0
2460         IF X2 > X20 THEN 2490
2470           XP1 = X1: XP2 = X2: N5 = 1: GOSUB 2860
2480           GOTO 2540
2490         IF X1 >= X20 THEN 2530
2500           XP1 = X1: XP2 = X20: N5 = 1: GOSUB 2860
2510           XP1 = X20: XP2 = X2: N5 = 0: GOSUB 2860
2520           GOTO 2540
2530           XP1 = X1: XP2 = X2: N5 = 0: GOSUB 2860
2540   NEXT I
2550   EXC = MYC / NC!: EYC = MXC / NC!          '*** Excentricidades giradas
2560   MXC = NC! * (EXC * S + EYC * C)
2570   MYC = NC! * (EXC * C - EYC * S)           '*** Esfzos en ejes grales

2580   FOR I = 1 TO NARM
2590     X = XIN(I): Y = YIN(I): XG = XIG(I): N = N(I)
2600     DX = 0: DY = 0: DXG = 0
2610     IF N = 1 THEN 2640
2620       N1 = N - 1: DX = (XFI(I) - X) / N1
2630       DY = (YFI(I) - Y) / N1: DXG = (XFG(I) - XG) / N1
2640     FOR J = 1 TO N
2650       EPS = AE * XG + BE: SGR = .21 * EPS
2660       IF SGR < -FYD THEN SGR = -FYD
2670       IF SGR > FYD THEN SGR = FYD
2680       DN = SGR * A(I)
2690       NS! = NS! + DN: MXS = MXS + DN * Y: MYS = MYS + DN * X
2700       X = X + DX: Y = Y + DY: XG = XG + DXG
2710     NEXT J
2720   NEXT I
2730   NU! = NC! + NS!: MXU = MXC + MXS          '*** Esfuerzos ltimos
2740   MYU = MYC + MYS
2750   EXU = MYU / NU!: EYU = MXU / NU!          '*** Excentr. resultantes
2760   ROU = SQR(EXU * EXU + EYU * EYU)
2770   IF KEX = 1 THEN ROU = 1 / ROU
2780   ERRRO = ROU - RO                          '*** Error radial
2790   IF ABS(EXU) >= .001 THEN 2830
2800      ERRAN = 90 - FI                        '*** Error angular
2810      IF EYU < 0 THEN ERRAN = -90 - FI
2820   GOTO 2850
2830      ERRAN = RAD * ATN(EYU / EXU * HX / HY) - FI
2840      IF EXU < 0 THEN ERRAN = ERRAN + 180
2850   RETURN

2860 '*** Trapecio:                             '** Subr. resultante tensiones
2870   Z1 = XP1: Z2 = XP2                       '** de hormign en un trapecio
2880   FOR J = 1 TO 5
2890     DEL(J) = (Z2 - Z1) / J
2900     Z1 = Z1 * XP1: Z2 = Z2 * XP2
2910   NEXT J
2920   IF N5 <> 0 THEN 2950
2930      ASIG = 0: BSIG = 0: CSIG = FCD
2940      GOTO 2980
2950      ASIG = A * AE * AE
2960      BSIG = 2 * A * AE * BE + B * AE
2970      CSIG = A * BE * BE + B * BE
2980   F4 = ASIG * AY
2990   F3 = BSIG * AY + ASIG * BY
3000   F2 = CSIG * AY + BSIG * BY
3010   F1 = CSIG * BY
3020   G5 = F4 * AY
3030   G4 = F3 * AY + ASIG * AY * BY
3040   G3 = F2 * AY + BSIG * AY * BY + ASIG * BY * BY
3050   G2 = F1 * AY + CSIG * AY * BY + BSIG * BY * BY
3060   G1 = CSIG * BY * BY
3070   NC! = NC! + SIGNO * (F4 * DEL(4) + F3 * DEL(3) + F2 * DEL(2) + F1 * DEL(1))
3080   MXC = MXC + SIGNO * (G5 * DEL(5) + G4 * DEL(4) + G3 * DEL(3) + G2 * DEL(2) + G1 * DEL(1)) / 2
3090   MYC = MYC + SIGNO * (F4 * DEL(5) + F3 * DEL(4) + F2 * DEL(3) + F1 * DEL(2))
3100   RETURN
