1010 '***** PROGRAMA DMNP: DIMENSIONAMTO SOPORTE ESBELTO FLEXOCOMPR. RECTA
1020 '***** Autores: F.Morn Cabr - A.Garca Meseguer - P.Jimnez Montoya
1030 '***** Ref: Hormign Armado, Montoya-Meseguer-Morn, Ed.G.Gili, Barna
1040 '***** Lenguaje: GW BASIC para compatibles IBM-PC/XT/AT/PS2 en MS-DOS

1050 DEFINT I-J, N: DIM OMEGA(3)
1060 FCD = 1750 * .9 / 1.5: FYD = 4.1 / 1.1   '*** Resistencias por defecto
1070 EPSY = FYD / 2100                        '*** Deform. lmite elstico

1080 CLS : PRINT
1090 T1$ = "     DIMENSIONAMIENTO SOPORTES ESBELTOS A FLEXOCOMPRESION Y PANDEO"
1100 T2$ = "  Seccin rectangular. Mtodo Curvaturas Referencia. Clculo riguroso"
1110 T3$ = "1=resistencias  2=dimens.sop  3=recubr.  4=Cd.Armado  5=solicitac. 6=fin"
1120 T4$ = SPACE$(20) + "Capacidad mecnica/barra: U =###.## t;   =###.## mm"
1130 T5$ = SPACE$(20) + "Capacidad mecnica/cara : U =###.## t"
1140 PRINT T1$: PRINT : PRINT T2$
1150 COLOR 0, 7: LOCATE 25, 1: PRINT T3$; : COLOR 7, 0

1160 WHILE TAREA% < 6
1170  PRINT
1180  INPUT "                                   Elige opcin = ", TAREA%
1190  IF TAREA% = 1 THEN GOSUB 1250      ' *** Resistencias
1200  IF TAREA% = 2 THEN GOSUB 1290      ' *** Escuadria
1210  IF TAREA% = 3 THEN GOSUB 1330      ' *** Recubrimiento
1220  IF TAREA% = 4 THEN GOSUB 1350      ' *** Codigo Armado
1230  IF TAREA% = 5 THEN GOSUB 1420      ' *** Solicitacion
1240 WEND: END

1250 ' *** Resistencias:
1260  INPUT "    Resistencias de calculo : fcd, fyd (kp/cm2) = ", FCD, FYD
1270  FCD = FCD * 10: FYD = FYD / 1000       '*** Paso a unidades de clculo
1280  EPSY = FYD / 2100

1290 ' *** Escuadria:
1300  INPUT "             Escuadra de la seccin: b, h (cm) = ", B, H
1310  B = B / 100: H = H / 100               '*** Paso a metros
1320  INPUT "        Longitud de pandeo del soporte: lo (cm) = ", L: L = L / 100

1330 ' *** Recubrimiento:
1340  INPUT "        Recubrimiento mecnico estimado: r (cm) = ", RM: RM = RM / 100

1350 ' *** Cod.Armado:
1360  INPUT "            Cdigo de Armado:  C A ( 2 cifras ) = ", CODA%
1370  NBF = CODA% \ 10                       '*** nm. barras frontales
1380  NBL = CODA% - 10 * NBF                 '*** nm. barras laterales
1390  R = RM / H: DELTA = 1 - R              '*** rec. y canto til relativos
1400  OMEGA(1) = 40 * FYD / FCD              '*** Cuanta mnima
1410  EXMIN = H / 20: IF EXMIN < .02 THEN EXMIN = .02  '*** Excentr. mnima

1420 ' *** Solicitacion:
1430  INPUT "Solicitac. actuante de clculo: Md (mt), Nd (t) = ", MD, ND!
1440  IF MD < 0 THEN MD = -MD
1450  IF MD < EXMIN * ND! THEN MD = EXMIN * ND!
1460  ETA = MD / ND! / H                       '*** Excentr. relativa
1470  CR = .0001 * L * L / H / H
1480  NUE! = ND! / FCD / B / H                 '*** Axil reducido

1490  NU1! = 2: NU2! = .8
1500  IF L = 0 THEN 1620
1510    W = NU1!: GOSUB 2420
1515    IF DEF.EXC = 1 THEN GOSUB 2890: RETURN
1520    CURV1 = CURV: EXR1 = EXR: DELW = 1
1530    WHILE ABS(DELW) > .001
1540      W = NU2!: GOSUB 2420
1545      IF DEF.EXC = 1 THEN GOSUB 2890: RETURN
1550      CURV2 = CURV: EXR2 = EXR
1560      AR = (CURV2 - CURV1) / (NU2! - NU1!): BR = (EXR2 - EXR1) / (NU2! - NU1!)
1570      DELW = NU2! - NU1! - (ETA + CR * CURV1 - EXR1) / (BR - AR * CR)
1580      NU1! = NU2!: CURV1 = CURV2: EXR1 = EXR2
1590      NU2! = NU2! - DELW
1595      IF NU2! < OMEGA(1) - .1 THEN DELW = 0
1600    WEND
1610    OMEGA(2) = NU2!                        '*** Cuanta por inestabilidad

1620    NPAS = 1
1630    WHILE NPAS = 1
1635     NU1! = 2: NU2! = .8: W = NU1!: GOSUB 2670
1640     IF DEF.EXC = 1 THEN GOSUB 2890: RETURN
1645     CURV1 = CURV: EXR1 = EXR: DELW = 1
1650     WHILE ABS(DELW) > .001
1660       W = NU2!: GOSUB 2670
1665       IF DEF.EXC = 1 THEN GOSUB 2890: RETURN
1670       CURV2 = CURV: EXR2 = EXR
1680       AR = (CURV2 - CURV1) / (NU2! - NU1!): BR = (EXR2 - EXR1) / (NU2! - NU1!)
1690       DELW = NU2! - NU1! - (ETA + CR * CURV1 - EXR1) / (BR - AR * CR)
1700       NU1! = NU2!: CURV1 = CURV2: EXR1 = EXR2
1710       NU2! = NU2! - DELW
1715       IF NU2! < OMEGA(1) - .1 THEN DELW = 0
1720     WEND
1730     IF NPAS = 2 THEN 1770
1740       OMEGA(3) = NU2!                     '*** Cuanta por agotamiento
1750       IF L = 0 THEN OMEGA(2) = OMEGA(3) + .1
1760       NPAS = 2: ETA = MD / ND! / H: CR = 0
1770    WEND

1780    W = OMEGA(2): IF W > OMEGA(3) THEN W = OMEGA(3)
1790    IF OMEGA(1) > W THEN I = 1: GOTO 1820
1800    IF OMEGA(3) > OMEGA(2) THEN I = 2: GOTO 1820
1810    I = 3
1820    UBAR = OMEGA(I) * FCD * B * H / (NBF + NBL - 2) / 2
1830    DIAM = 20 * SQR(UBAR / FYD / 3.1416)
1840    PRINT "Criterio de armado:  ";
1850    IF I = 1 THEN PRINT "Cuanta mnima": GOTO 1880
1860    IF I = 2 THEN PRINT "Inestabilidad": GOTO 1880
1870   PRINT "Agotamiento"
1880   IF NBF = 1 THEN PRINT USING T5$; UBAR ELSE PRINT USING T4$; UBAR, DIAM
1890   RETURN

1900 ' *** esReV:                                 '*** Subr. esclava de ReVAc
1910  IF XI = 0 THEN RETURN
1920  A1 = EPSC / XI
1930  A2 = A1 * A1
1940  A1 = 850 * A1
1950  A2 = -212500! * A2
1960  Y = XI
1970  IF EPSC > .002 THEN Y = .002 * XI / EPSC
1980  YC = Y * Y
1990  Y3 = YC * Y / 3
2000  I1! = A1 * YC / 2 + A2 * Y3 + .85 * (XI - Y)
2010  I2! = A1 * Y3 + A2 * Y3 * Y * .75 + .425 * (XI - Y) * (XI + Y)
2020  AXI = AXI + S * I1!
2030  MOM = MOM + S * I2!
2040  RETURN

2050 '*** ReVAc:                                     '*** Subrutina principal
2060  DEF.EXC = 0
2070  IF EPSC > .0035001 THEN DEF.EXC = 1
2080  IF EPSS < -.0100001 OR EPSC < EPSS - .000001 THEN DEF.EXC = 1
2090  IF (.4285 * EPSS + (.5714 - R) * EPSC) / DELTA > .002 THEN DEF.EXC = 1
2100  IF DEF.EXC = 1 THEN RETURN
2110  IF ABS(EPSC - EPSS) < .000001 THEN 2220
2120    E3 = (EPSC - EPSS) / DELTA
2130    XI = EPSC / E3
2140    AXI = 0: MOM = 0
2150    S = 1: GOSUB 1900
2160    IF XI <= 1 THEN 2200
2170      EPSC = EPSC * (XI - 1) / XI: XI = XI - 1
2180      S = -1: GOSUB 1900
2190      XI = XI + 1: EPSC = EPSC * XI / (XI - 1)
2200    IF XI <> 0 THEN MOM = AXI * (MOM / AXI - XI + .5)
2210    GOTO 2260
2220    MOM = 0: E3 = 0
2230    IF EPSC <= 0 THEN AXI = 0: GOTO 2260
2240    IF EPSC >= .002 THEN AXI = .85: GOTO 2260
2250    AXI = (850 - 212500! * EPSC) * EPSC
2260  E4 = EPSS: Y = R - .5: DY = 2 * Y / (1 - NBL)
2270  S1 = 0: S2 = 0: E6 = E3 * DY
2280  FOR I = 1 TO NBL
2290    IF E4 >= EPSY THEN S = 1: GOTO 2320
2300    IF E4 <= -EPSY THEN S = -1: GOTO 2320
2310    S = E4 / EPSY
2320    IF I = 1 OR I = NBL THEN S = NBF * S ELSE S = S + S
2330    S1 = S1 + S
2340    S2 = S2 + S * Y
2350    E4 = E4 + E6
2360    Y = Y + DY
2370  NEXT I
2380  S = W / 2 / (NBF + NBL - 2)
2390  AXI = AXI + S1 * S
2400  MOM = MOM + S2 * S
2410  RETURN

2420 ' *** Curva.Ref.Inest:                   '*** Curvatura Referenc.Inestab.
2430  IF NUE! <= .32 THEN GOTO 2560
2440    EPSC = EPSY: EPSS = EPSY
2441    IF EPSY <= .002 THEN GOTO 2444
2442      EPSC = .002 + (EPSY - .002) * .4286 / (.4286 - R)
2443      EPSS = .002 - (EPSY - .002) * (.5714 - R) / (.4286 - R)
2444    GOSUB 2050
2445    IF DEF.EXC = 1 THEN RETURN
2450    IF NUE! > AXI THEN PRINT "AXIL EXCESIVO": END
2460    X1 = -EPSY: X2 = EPSY
2465    IF EPSY > .002 THEN X2 = .002 - (EPSY - .002) * (.5714-R) / (.4286-R)
2470    EPSS = X1: EPSC = (DELTA * EPSY - R * EPSS) / (DELTA - R)
2480    GOSUB 2050: Y1 = AXI - NUE!: Y2 = Y1
2485    IF DEF.EXC = 1 THEN RETURN
2490    WHILE ABS(Y2) > .0001
2500      EPSS = X2: EPSC = (DELTA * EPSY - R * EPSS) / (DELTA - R)
2510      GOSUB 2050: Y2 = AXI - NUE!
2515      IF DEF.EXC = 1 THEN RETURN
2520      DX = (X1 - X2) / (Y1 - Y2) * Y2
2530      X1 = X2: Y1 = Y2: X2 = X2 - DX
2540    WEND
2550    GOTO 2640
2560    EPSS = -EPSY
2570    X1 = .001: X2 = .002
2580    EPSC = X1: GOSUB 2050: Y1 = AXI - NUE!: Y2 = Y1
2585    IF DEF.EXC = 1 THEN RETURN
2590    WHILE ABS(Y2) > .0001
2600      EPSC = X2: GOSUB 2050: Y2 = AXI - NUE!
2605      IF DEF.EXC = 1 THEN RETURN
2610      DX = (X1 - X2) / (Y1 - Y2) * Y2
2620      X1 = X2: Y1 = Y2: X2 = X2 - DX
2630    WEND
2640  EXR = MOM / AXI
2650  CURV = (EPSC - EPSS) / DELTA * 1000
2660  RETURN

2670 '*** Curva.Ref.Agota:                     '*** Curvatura Referencia Agot.
2680  X1 = .5: X2 = .8
2690  XI = X1: GOSUB 2780: GOSUB 2050: Y1 = AXI - NUE!: Y2 = Y1
2695  IF DEF.EXC = 1 THEN RETURN
2700  WHILE ABS(Y2) > .0001
2710    XI = X2: GOSUB 2780: GOSUB 2050: Y2 = AXI - NUE!
2715    IF DEF.EXC = 1 THEN RETURN
2720    DX = (X1 - X2) / (Y1 - Y2) * Y2
2730    X1 = X2: Y1 = Y2: X2 = X2 - DX
2740  WEND
2750  EXR = MOM / AXI
2760  CURV = (EPSC - EPSS) / DELTA * 1000
2770  RETURN

2780 '*** Defor:                                 '*** Clculo de deformaciones
2790  IF XI > .2593 * DELTA THEN 2820            '*** en fibras horm. y armad.
2800    EPSC = .01 * XI / (DELTA - XI)
2810    EPSS = -.01: RETURN
2820  IF XI > 1 THEN 2860
2830    EPSC = .0035
2840    EPSS = .0035 * (XI - DELTA) / XI
2850    RETURN
2860    EPSC = .005 - .0015 * XI: EPSS = .0035 * R
2870    EPSS = EPSS + (XI - 1) * (.002 - EPSS)
2880    RETURN

2890 '*** No.Conv:                               '** Salida si no converge
2900     PRINT SPACE$(40); "No converge"
2910     RETURN