1010 '***** PROGRAMA DME: DIMENSIONAMIENTO SECC.RECTANG./T -FLEXION SIMPLE
1020 '***** Autores: F.Morn Cabr - A.Garca Meseguer - P.Jimnez Montoya
1030 '***** Ref: Hormign Armado, Montoya-Meseguer-Morn, Ed.G.Gili, Barna
1040 '***** Lenguaje: GW BASIC para compatibles IBM-PC/XT/AT/PS2 en MS-DOS

1050 DEFINT I-L
1060 DIM CH(7)                                         '*** Coefs. Chebyshev
1070    CH(1) = .0581: CH(2) = .2352: CH(3) = .338: CH(4) = .5
1080    CH(7) = .9419: CH(6) = .7648: CH(5) = .662
1090 FCD = 1750 / 1.5: FYD = 4.1 / 1.1       '*** Resistencias por defecto

1100 CLS : PRINT : PRINT
1110 T1$ = "            DIMENSIONAMIENTO DE SECCIONES EN FLEXION SIMPLE"
1120 T2$ = "    Seccin Rectang. o T. Mtodo Parbola-Rectngulo. Clculo exacto"
1130 T3$ = "   1=resistencias  2=escuadra  3=recubr.  4=armado  5=momento  6=fin"
1140 T4$ = "                        Armadura en traccin: n =###.##;  =###.## mm"
1150 T5$ = "                      Armadura en compresin: n'=###.##; '=###.## mm"
1160 PRINT T1$: PRINT T2$
1170 COLOR 0, 7: LOCATE 25, 1: PRINT T3$; : COLOR 7, 0

1180 WHILE TAREA% < 6
1190  PRINT
1200  INPUT "                                   Elige opcin = ", TAREA%
1210  IF TAREA% = 1 THEN GOSUB 1270        ' *** Resistencias
1220  IF TAREA% = 2 THEN GOSUB 1300        ' *** Escuadria
1230  IF TAREA% = 3 THEN GOSUB 1380        ' *** Recubrimiento
1240  IF TAREA% = 4 THEN GOSUB 1410        ' *** Armado
1250  IF TAREA% = 5 THEN GOSUB 1500        ' *** Momento
1260 WEND: END

1270 ' *** Resistencias:
1280  INPUT "    Resistencias de calculo : fcd, fyd (kp/cm2) = ", FCD, FYD
1290  FCD = FCD * 10: FYD = FYD / 1000         '*** Paso a unidades de clculo

1300 ' *** Escuadria:
1310  INPUT "             Escuadra de la seccin: b, h (cm) = ", B, H
1320  B = B / 100: H = H / 100                 '*** Paso a metros
1330  SECTE = 0: AC = B * H                    '*** Area sec. hormign m2
1340  IF B > 0 THEN 1380
1350  INPUT "Ancho del nervio y espesor del ala: bw, hf (cm) = ", BW, HF
1360  B = -B: BW = BW / 100: HF = HF / 100     '*** Paso a metros
1370  SECTE = 1: AC = B * HF + BW * (H - HF)

1380 ' *** Recubrimiento:
1390  INPUT "        Recubrimiento mecnico estimado: r (cm) = ", RMEC
1400  RMEC = RMEC / 100                        '*** Paso a metros

1410 '*** Armado:
1420  INPUT " Armadura compresin y traccin: n', ',  (mm) = ", NP, FIP, FI
1430  AP = 3.141593 * NP * FIP * FIP / 400     '*** Area arm. compres. cm2
1440  IF FYD < 3.41 OR FYD > 3.73 THEN 1460
1450     ROMIN = .0033: GOTO 1490              '*** Cuant. geom. mnima
1460  IF FYD < 4.25 OR FYD > 4.64 THEN 1480
1470     ROMIN = .0028: GOTO 1490
1480     ROMIN = .016 / (FYD + 1.3)
1490  AMIN = 10000 * AC * ROMIN: NPA = NP      '*** Area mn. arm. tracc. cm2

1500 '*** Momento:
1510  INPUT "            Momento flector de clculo: Md (mt) = ", MD
1520  IF MD < 0 THEN 1510
1530  FCMAX = .85 * FCD                        '*** Tens. mx. Diagrama P-R
1540  D = H - RMEC                             '*** canto til

1550  X1 = .628: X = X1: GOSUB 1830            '*** Prof. lmite
1560  IF MU <= MD THEN 1660                    '*** Necesita ms Arm.comp.
1570    E1 = ERM: X2 = .21                     '*** error y nuevo tanteo
1580    WHILE ABS(ERM) > .0001                 '*** bsqueda posicin f.n.
1590      X = X2: GOSUB 1830: E2 = ERM         '*** error del ultimo tanteo
1600      DX = (X1 - X2) / (E1 - E2) * E2      '*** correccin rgula falsi
1610      IF DX > .2 THEN DX = .2              '*** valor mximo correccin
1620      IF DX < -.2 THEN DX = -.2            '*** valor mnimo
1630      IF DX > X2 THEN DX = X2 - .01        '*** evitar valores negativos
1640      X1 = X2: E1 = E2: X2 = X2 - DX       '*** nuevos valores tanteo
1650    WEND: GOTO 1720
1660    DN = (MD - MU) / (D - RMEC)            '*** Incremento de axil
1670    DA = DN / S1                           '*** Incremento de rea
1680    NU = NU + DN
1690    IF FIP = 0 THEN FIP = FI
1700    ABARP = 3.141593 * FIP * FIP / 400     '*** Area de cada barra
1710    NP = (AP + DA) / ABARP       	       '*** Nm. total de barras

1720  NS = NU                                  '*** Axil de la arm. en trac.
1730  S2 = .21 * EPSM * (1 - X) / X            '*** Tensin idem.
1740  IF S2 < -FYD THEN S2 = -FYD
1750  IF S2 > FYD THEN S2 = FYD
1760  A = NS / S2                              '*** Area idem
1770  IF A < AMIN THEN A = AMIN
1780  ABAR = 3.141593 * FI * FI / 400          '*** Area de cada barra
1790  N = A / ABAR
1800  PRINT USING T4$; N, FI
1810  IF NP > 0 THEN PRINT USING T5$; NP, FIP: NP = NPA
1820  RETURN                                   '*** Comn a las 5 subrutinas

1830 '*** Resultante:                          '*** Clculo para una f.n.
1840    IF X < .2593 THEN EPSM = 100 * X / (1 - X) ELSE EPSM = 35
1850    XD = X * D                             '*** Prof. f.n. en m
1860    NC = 0: MC = 0                         '*** Esfuerzos hormign
1870    IF SECTE = 0 OR XD <= HF THEN 1910
1880       U1 = 0: U2 = HF: BU = B: GOSUB 2010    '*** Secc. T: Zona del ala
1890       U1 = HF: U2 = XD: BU = BW: GOSUB 2010  '*** Zona del nervio
1900       GOTO 1920
1910       U1 = 0: U2 = XD: BU = B: GOSUB 2010    '*** Secc. rectangular
1920    S1 = .21 * EPSM * (X - RMEC / D) / X      '*** Tensin armadura
1930    IF S1 < -FYD THEN S1 = -FYD
1940    IF S1 > FYD THEN S1 = FYD
1950    NS = AP * S1                              '*** Axil armadura
1960    MS = AP * S1 * (D - RMEC)                 '*** Momento armadura
1970    NU = NC + NS                              '*** Axil ltimo
1980    MU = MC + MS                              '*** Momento ltimo
1990    ERM = MD - MU                             '*** Error en momentos
2000    RETURN

2010 '*** Integra:                             '*** Clculo Nc, Mc (Chebyshev)
2020    DU = U2 - U1
2030    FOR I = 1 TO 7
2040      U = U1 + DU * CH(I)                  '*** Profundidad fibra
2050      EPSC = EPSM * (X - U / D) / X        '*** Deformacin hormign
2060      SIGC = FCMAX                         '*** Tensin hormign
2070      IF EPSC < 20 THEN AUX = 1 - EPSC / 20: SIGC = FCMAX * (1 - AUX * AUX)
2080      DN = SIGC * BU * DU / 7              '*** Axil fibra
2090      NC = NC + DN
2100      MC = MC + DN * (D - U)
2110    NEXT I
2120    RETURN

