1010 '***** PROGRAMA DMNE: DIMENSIONAMIENTO SEC.RECTANG. FLEXOCOMPR. RECTA
1020 '***** Autores: F.Morn Cabr - A.Garca Meseguer - P.Jimnez Montoya
1030 '***** Ref: Hormign Armado, Montoya-Meseguer-Morn, Ed.G.Gili, Barna
1040 '***** Lenguaje: GW BASIC para compatibles IBM-PC/XT/AT/PS2 en MS-DOS

1050 FCD = 1750 * .9 / 1.5: FYD = 4.1 / 1.1   '*** Resistencias por defecto

1060 CLS : PRINT
1070 T1$ = "         DIMENSIONAMIENTO DE SOPORTES CORTOS A FLEXOCOMPRESION": PRINT
1080 T2$ = "    Seccin rectangular. Mtodo Parbola-Rectngulo. Clculo exacto"
1090 T3$ = "1=resistencias  2=escuadra  3=recubr.  4=Cd.Armado  5=solicitac. 6=fin"
1100 T4$ = "Capacidad mecnica/barra: U =###.## t;   =###.## mm"
1110 T5$ = "Capacidad mecnica/cara : U =###.## t"
1120 PRINT T1$: PRINT T2$
1130 COLOR 0, 7: LOCATE 25, 1: PRINT T3$; : COLOR 7, 0

1140 WHILE TAREA% < 6
1150  PRINT
1160  INPUT "                                   Elige opcin = ", TAREA%
1170  IF TAREA% = 1 THEN GOSUB 1230      ' *** Resistencias
1180  IF TAREA% = 2 THEN GOSUB 1260      ' *** Escuadria
1190  IF TAREA% = 3 THEN GOSUB 1290      ' *** Recubrimiento
1200  IF TAREA% = 4 THEN GOSUB 1320      ' *** Codigo Armado
1210  IF TAREA% = 5 THEN GOSUB 1490      ' *** Solicitacion
1220 WEND: END

1230 ' *** Resistencias:
1240  INPUT "    Resistencias de calculo : fcd, fyd (kp/cm2) = ", FCD, FYD
1250  FCD = FCD * 10: FYD = FYD / 1000       '*** Paso a unidades de clculo

1260 ' *** Escuadria:
1270  INPUT "             Escuadra de la seccin: b, h (cm) = ", B, H
1280  B = B / 100: H = H / 100               '*** Paso a metros

1290 ' *** Recubrimiento:
1300  INPUT "        Recubrimiento mecnico estimado: r (cm) = ", RMEC
1310  RMEC = RMEC / 100                      '*** Paso a metros

1320 ' *** Cod.Armado:
1330  INPUT "                Cdigo de Armado: CA (2 cifras) = ", CODA%
1340  NBF% = CODA% \ 10                      '*** nm. barras frontales
1350  NBL% = CODA% - 10 * NBF%               '*** nm. barras laterales
1360  N%(1) = NBF%: N%(NBL%) = NBF%          '*** barras 1a y ult. capa
1370  Y(1) = H / 2 - RMEC: Y(NBL%) = -Y(1)   '*** prof.  1a y ult. capa
1380  DCAPA = (H - 2 * RMEC) / (NBL% - 1)    '*** distancia entre capas
1390  FOR I% = 2 TO NBL% - 1
1400    N%(I%) = 2                           '*** nm. barras de la capa
1410    Y(I%) = Y(I% - 1) - DCAPA            '*** prof. de la capa
1420  NEXT I%
1430  D = H - RMEC                           '*** canto til
1440  NBAR% = 2 * (NBF% + NBL%) - 4          '*** nm. total de barras
1450  UMIN = 40 * B * H * FYD / NBAR%        '*** cap.mec.mn.por barra
1460  EXMIN = .02 * H / B                    '*** excentricidad mnima
1470  IF EXMIN < .02 THEN EXMIN = .02
1480  IF EXMIN < H / 20 THEN EXMIN = H / 20

1490 ' *** Solicitacion:
1500  INPUT "Solicitacin actuante de clculo: Md, Nd (mt,t) = ", MD, ND
1510  IF MD < 0 THEN MD = -MD
1520  IF MD < ND * EXMIN THEN MD = ND * EXMIN
1530  X1 = .7 * H: X2 = .71 * H                '*** valores tanteo prof.f.n.
1540  X3 = X1: GOSUB 1710: E1 = ERRO           '*** error del 1er tanteo
1550  WHILE ABS(ERRO) > .0001
1560    X3 = X2: GOSUB 1710: E2 = ERRO         '*** error del ultimo tanteo
1570    DX = (X1 - X2) / (E1 - E2) * E2        '*** correccin rgula falsi
1580    IF DX > .2 * H THEN DX = .2 * H        '*** valor mximo correccin
1590    IF DX < -.2 * H THEN DX = -.2 * H      '*** valor mnimo
1600    IF ND > 0 AND DX * E2 > 0 THEN DX = -DX'*** direccin equivocada
1610    IF DX > X2 THEN DX = X2 - .01          '*** evitar valores negativos
1620    X1 = X2: E1 = E2: X2 = X2 - DX         '*** nuevos valores tanteo
1630  WEND
1640  ABAR = (MD - MC) / MS                    '*** rea de una barra
1650  UBAR = ABAR * FYD                        '*** capac.mecn. de una barra
1660  IF UBAR < UMIN THEN UBAR = UMIN: ABAR = UMIN / FYD
1670  DIAM = 20 * SQR(ABAR / 3.1416)           '*** dimetro de las barras
1680  PRINT SPACE$(20);
1690  IF NBF% = 1 THEN PRINT USING T5$; UBAR ELSE PRINT USING T4$; UBAR, DIAM
1700  RETURN                                   '*** comn a las 5 subrutinas

1710 ' *** RESULTANTE:                         '*** Clculo para una f.n.
1720  X = X3 / D                               '*** prof.relativa f.n.
1730  IF X > .1667 THEN 1770                   '*** dominio 2a
1740    FI = 4.25 * X * (3 - 8 * X) / 3 / (1 - X) / (1 - X)'*** parmetro axil relativo
1750    LAMBDA = (4 - 9 * X) / (12 - 32 * X)   '*** parmetro prof. relativa
1760    EPSC = 100 * X / (1 - X): GOTO 1900    '*** deform. fibra superior
1770  IF X > .2593 THEN 1810                   '*** dominio 2b
1780    FI = .85 * (16 * X - 1) / 15 / X
1790    LAMBDA = ((171 * X - 22) * X + 1) / (320 * X - 20) / X
1800    EPSC = 100 * X / (1 - X): GOTO 1900
1810  IF X3 > H THEN 1850                      '*** dominios 3 y 4
1820    FI = .6881
1830    LAMBDA = .416
1840    EPSC = 35: GOTO 1900
1850  X = X3 / H                               '*** dominio 5: nueva def.de x
1860    FI = .85 - 54.4 / 21 / (7 * X - 3) / (7 * X - 3)
1870    LAMBDA = 3 / 14 * ((2401 * X - 2058) * X + 185)
1880    LAMBDA = LAMBDA / ((1029 * X - 882) * X + 125)
1890    EPSC = 20 * X / (X - 3 / 7)

1900  IF X3 > H THEN 1940
1910    NC = X3 * B * FCD * FI                 '*** axil hormign
1920    MC = NC * (H / 2 - X3 * LAMBDA)        '*** momento hormign
1930  GOTO 1960
1940    NC = H * B * FCD * FI
1950    MC = NC * H * (.5 - LAMBDA)

1960  NS = 0: MS = 0                           '*** axil y momento armaduras
1970  EPSS = .21 * EPSC                        '*** valor auxiliar clc. sigs
1980  FOR I% = 1 TO NBL%                       '*** para cada capa armaduras
1990    SIGS = EPSS * (X3 + Y(I%) - H / 2) / X3'*** tensin acero en la capa
2000    IF SIGS < -FYD THEN SIGS = -FYD
2010    IF SIGS > FYD THEN SIGS = FYD
2020    NS = NS + SIGS * N%(I%)
2030    MS = MS + SIGS * N%(I%) * Y(I%)
2040  NEXT I%
2050  NF = ND - NC: MF = MD - MC               '*** esfuerzos diferencia
2060  ERRO = (NF - NS * MF / MS) / ND          '*** error en axiles
2070 RETURN
