1010 '***** PROGRAMA CMNE: COMPROBACION SECCION RECTANG. FLEXOCOMPR. RECTA
1020 '***** Autores: F.Morn Cabr - A.Garca Meseguer - P.Jimnez Montoya
1030 '***** Ref: Hormign Armado, Montoya-Meseguer-Morn, Ed.G.Gili, Barna
1040 '***** Lenguaje: GW BASIC para compatibles IBM-PC/XT/AT/PS2 en MS-DOS

1050 FCD = 1750 * .9 / 1.5: FYD = 4.1 / 1.1   '*** Resistencias por defecto

1060 CLS : PRINT
1070 T1$ = "           COMPROBACION DE SOPORTES CORTOS A FLEXOCOMPRESION"
1080 T2$ = "    Seccin rectangular. Mtodo Parbola-Rectngulo. Clculo exacto"
1090 T3$ = " 1=resistencias  2=escuadra  3=recubr.  4=Armado   5=solicitac. 6=fin"
1100 T4$ = SPACE$(20) + "            Axil ltimo: Nu =###.## t;  gamc =##.##"
1110 PRINT T1$: PRINT T2$
1120 COLOR 0, 7: LOCATE 25, 1: PRINT T3$; : COLOR 7, 0

1130 WHILE TAREA% < 6
1140  PRINT
1150  INPUT "                                   Elige opcin = ", TAREA%
1160  IF TAREA% = 1 THEN GOSUB 1220      ' *** Resistencias
1170  IF TAREA% = 2 THEN GOSUB 1250      ' *** Escuadria
1180  IF TAREA% = 3 THEN GOSUB 1290      ' *** Recubrimiento
1190  IF TAREA% = 4 THEN GOSUB 1310      ' *** Armado
1200  IF TAREA% = 5 THEN GOSUB 1500      ' *** Solicitacion
1210 WEND: END

1220 ' *** Resistencias:
1230  INPUT "    Resistencias de calculo : fcd, fyd (kp/cm2) = ", FCD, FYD
1240  FCD = FCD * 10: FYD = FYD / 1000       '*** Paso a unidades de clculo

1250 ' *** Escuadria:
1260  INPUT "             Escuadra de la seccin: b, h (cm) = ", B, H
1270  B = B / 100: H = H / 100               '*** Paso a metros

1280 ' *** Recubrimiento:
1290  INPUT "        Recubrimiento mecnico estimado: r (cm) = ", RMEC
1300  RMEC = RMEC / 100                      '*** Paso a metros

1310 ' *** Armado:
1320  INPUT "        Cdigo de Armado y dimetro: CA,  (mm) = ", CODA%, DI
1330  NBF% = CODA% \ 10                      '*** nm. barras frontales
1340  NBL% = CODA% - 10 * NBF%               '*** nm. barras laterales
1350  N%(1) = NBF%: N%(NBL%) = NBF%          '*** barras 1a y ult. capa
1360  Y(1) = H / 2 - RMEC: Y(NBL%) = -Y(1)   '*** prof.  1a y ult. capa
1370  DCAPA = (H - 2 * RMEC) / (NBL% - 1)    '*** distancia entre capas
1380  FOR I% = 2 TO NBL% - 1
1390    N%(I%) = 2                           '*** nm. barras de la capa
1400    Y(I%) = Y(I% - 1) - DCAPA            '*** prof. de la capa
1410  NEXT I%
1420  D = H - RMEC                           '*** canto til
1430  NBAR% = 2 * (NBF% + NBL%) - 4          '*** nm. total de barras
1440  AMIN = 40 * B * H / NBAR%              '*** rea mnima por barra cm2
1450  ABAR = 3.141593 * DI * DI / 400        '*** rea real de cada barra
1460  IF ABAR < AMIN THEN PRINT SPACE$(20);"Ojo! No cumple cuanta mnima"
1470  EXMIN = .02 * H / B                    '*** excentricidad mnima
1480  IF EXMIN < .02 THEN EXMIN = .02
1490  IF EXMIN < H / 20 THEN EXMIN = H / 20

1500 ' *** Solicitacion:
1510  INPUT "Solicitacin actuante de clculo: Md, Nd (mt,t) = ", MD, ND
1520  IF MD < 0 THEN MD = -MD
1530  EX = MD / ND
1540  IF EX < EXMIN THEN EX = EXMIN
1550  IF EX > H THEN EX = 1 / EX: KEX = 1 ELSE KEX = 0
1560  X1 = .6 * H: X2 = .9 * H               '*** valores tanteo prof.f.n.
1570  X3 = X1: GOSUB 1690: E1 = ERRO         '*** error del 1er tanteo
1580  WHILE ABS(ERRO) > .0001                '*** bsqueda posicin f.n.
1590    X3 = X2: GOSUB 1690: E2 = ERRO       '*** error del ultimo tanteo
1600    DX = (X1 - X2) / (E1 - E2) * E2      '*** correccin rgula falsi
1610    IF DX > .2 * H THEN DX = .2 * H      '*** valor mximo correccin
1620    IF DX < -.2 * H THEN DX = -.2 * H    '*** valor mnimo
1630   'IF ND > 0 AND DX * E2 > 0 THEN DX = -DX   '*** direccin equivocada
1640    IF DX > X2 THEN DX = X2 - .01        '*** evitar valores negativos
1650    X1 = X2: E1 = E2: X2 = X2 - DX       '*** nuevos valores tanteo
1660  WEND
1670  PRINT USING T4$; NU, NU/ND
1680  RETURN                                 '*** Comn a las 5 subrutinas

1690 ' *** Resultante:                       '*** Clculo para una f.n.
1700  X = X3 / D                             '*** prof.relativa f.n.
1710  IF X > .1667 THEN 1750                 '*** dominio 2a
1720    FI = 4.25 * X * (3 - 8 * X) / 3 / (1 - X) / (1 - X)'*** parm.axil
1730    LAMBDA = (4 - 9 * X) / (12 - 32 * X) '*** parmetro prof. relativa
1740    EPSC = 100 * X / (1 - X): GOTO 1880  '*** deform. fibra superior
1750  IF X > .2593 THEN 1790                 '*** dominio 2b
1760    FI = .85 * (16 * X - 1) / 15 / X
1770    LAMBDA = ((171 * X - 22) * X + 1) / (320 * X - 20) / X
1780    EPSC = 100 * X / (1 - X): GOTO 1880
1790  IF X3 > H THEN 1830                    '*** dominios 3 y 4
1800    FI = .6881
1810    LAMBDA = .416
1820    EPSC = 35: GOTO 1880
1830  X = X3 / H                             '*** dominio 5: nueva def.de x
1840    FI = .85 - 54.4 / 21 / (7 * X - 3) / (7 * X - 3)
1850    LAMBDA = 3 / 14 * ((2401 * X - 2058) * X + 185)
1860    LAMBDA = LAMBDA / ((1029 * X - 882) * X + 125)
1870    EPSC = 20 * X / (X - 3 / 7)
1880  IF X3 > H THEN 1920
1890    NC = X3 * B * FCD * FI               '*** axil hormign
1900    MC = NC * (H / 2 - X3 * LAMBDA)      '*** momento hormign
1910  GOTO 1940
1920    NC = H * B * FCD * FI
1930    MC = NC * H * (.5 - LAMBDA)

1940  NS = 0: MS = 0                         '*** axil y momento armaduras
1950  EPSS = .21 * EPSC                      '*** valor auxiliar clc. sigs
1960  FOR I% = 1 TO NBL%                     '*** para cada capa armaduras
1970    SIGS = EPSS * (X3 + Y(I%) - H / 2) / X3'*** tensin acero en la capa
1980    IF SIGS < -FYD THEN SIGS = -FYD
1990    IF SIGS > FYD THEN SIGS = FYD
2000    NS = NS + SIGS * N%(I%)
2010    MS = MS + SIGS * N%(I%) * Y(I%)
2020  NEXT I%
2030  NU = NC + NS * ABAR: MU = MC + MS * ABAR
2040  IF KEX = 0 THEN EU = MU / NU ELSE EU = NU / MU
2050  ERRO = EU - EX                         '*** error en excentricidades
2060 RETURN
