1010 '***** PROGRAMA DMNA: DIMENSIONAM.SECCION CIRCULAR/ANULAR FLEXOCOMPR.
1020 '***** Autores: F.Morn Cabr - A.Garca Meseguer - P.Jimnez Montoya
1030 '***** Ref: Hormign Armado, Montoya-Meseguer-Morn, Ed.G.Gili, Barna
1040 '***** Lenguaje: GW BASIC para compatibles IBM-PC/XT/AT/PS2 en MS-DOS

1050 DEFINT I-J, N: DIM N(9), Y(9), K(7)
1060 K(1) = .0581: K(2) = .2352: K(3) = .338: K(4) = .5  '*** Coefs.Chebyshev
1070 K(7) = .9419: K(6) = .7648: K(5) = .662: CLS
1080 FCD = 1750 * .9 / 1.5: FYD = 4.1 / 1.1     '*** Resistencias por defecto

1090 CLS : PRINT
1100 T1$ = "         DIMENSIONAMIENTO DE SOPORTES CORTOS A FLEXOCOMPRESION"
1110 T2$ = "   Seccin Circular/Anular. Mtodo Parbola-Rectngulo. Clculo exacto"
1120 T3$ = "1=resistencias  2=seccin   3=recubr.  4=nm. barras  5=solicitac. 6=fin"
1130 T4$ = "Capacidad mecnica/barra: U =###.## t;   =###.## mm"
1140 PRINT T1$: PRINT: PRINT T2$
1150 COLOR 0, 7: LOCATE 25, 1: PRINT T3$; : COLOR 7, 0

1160 WHILE TAREA% < 6
1170  PRINT
1180  INPUT "                                   Elige opcin = ", TAREA%
1190  IF TAREA% = 1 THEN GOSUB 1250        ' *** Resistencias
1200  IF TAREA% = 2 THEN GOSUB 1280        ' *** Escuadria
1210  IF TAREA% = 3 THEN GOSUB 1310        ' *** Recubrimiento
1220  IF TAREA% = 4 THEN GOSUB 1340        ' *** Nm. barras
1230  IF TAREA% = 5 THEN GOSUB 1500        ' *** Solicitacion
1240 WEND: END

1250 ' *** Resistencias:
1260  INPUT "    Resistencias de calculo : fcd, fyd (kp/cm2) = ", FCD, FYD
1270  FCD = FCD * 10: FYD = FYD / 1000       '*** Paso a unidades de clculo

1280 ' *** Escuadria:
1290  INPUT "    Dimetro y espesor de la seccin: h, e (cm) = ", H, ESP
1300  H = H / 100: ESP = ESP / 100           '*** Paso a metros

1310 ' *** Recubrimiento:
1320  INPUT "        Recubrimiento mecnico estimado: r (cm) = ", C
1330  C = C / 100                            '*** Paso a metros

1340 ' *** Nm. barras:
1350  INPUT "          Nmero de barras (mn=6; mx=18):  Nb = ", NB
1360  IF NB < 6 OR NB > 18 THEN 1350
1370  HI = H - 2 * ESP: H2 = H / 2               '*** Dim.hueco y radio
1380  NB2 = NB \ 2                               '*** Nm. capas de barras
1390  FI = 3.141593 / NB2                        '*** Diferencia ang. capas
1400  R = H2 - C: FI0 = FI / 2                   '*** Radio armaduras
1410  FOR I = 1 TO NB2
1420      N(I) = 2                               '*** Nm. barras/capa
1430      Y(I) = R * COS(FI0)                    '*** Altura capa
1440      FI0 = FI0 + FI
1450  NEXT I
1460  D = H - C: AC = (H - ESP) * ESP * 3.141593 '*** Canto til y rea sec.
1470  UMIN = 40 * FYD * AC / NB                  '*** Cap.mec.mn.por barra
1480  EMIN = H / 20                              '*** Excentricidad mnima
1490  IF EMIN < .02 THEN EMIN = .02

1500 ' *** Solicitacion:
1510  INPUT "Solicitacin actuante de clculo: Md, Nd (mt,t) = ", MD, ND!
1520  IF MD < 0 THEN MD = -MD
1530  IF ND! = 0 THEN ND! = -1                   '*** Ojo no valen axiles de
1540  IF ABS(ND!) < 1 THEN ND! = SGN(ND!)        '*** pequeo valor absoluto
1550  IF MD < EMIN * ND! THEN MD = EMIN * ND!
1560  X1 = .7 * H: X2 = .71 * H                  '*** valores tanteo prof.f.n.
1570  X3 = X1: GOSUB 1740: E1 = ERRO             '*** error del 1er tanteo
1580  WHILE ABS(ERRO) > .0001
1590    X3 = X2: GOSUB 1740: E2 = ERRO           '*** error del ultimo tanteo
1600    DX = (X1 - X2) / (E1 - E2) * E2          '*** correccin rgula falsi
1610    IF DX > .2 * H THEN DX = .2 * H          '*** valor mximo correccin
1620    IF DX < -.2 * H THEN DX = -.2 * H        '*** valor mnimo
1630    IF ND!> 0 AND DX * E2 > 0 THEN DX = -DX  '*** direccin equivocada
1640    IF DX > X2 THEN DX = X2 - .01            '*** evitar valores negativos
1650    X1 = X2: E1 = E2: X2 = X2 - DX           '*** nuevos valores tanteo
1660  WEND
1670  ABAR = (MD - MC) / MS                      '*** rea de una barra
1680  UBAR = ABAR * FYD                          '*** cap.mecn. de una barra
1690  IF UBAR < UMIN THEN UBAR = UMIN: ABAR = UMIN / FYD
1700  DIAM = 20 * SQR(ABAR / 3.1416)             '*** dimetro de las barras
1710  PRINT SPACE$(20);
1720  PRINT USING T4$; UBAR, DIAM
1730  RETURN                                     '*** comn a las 5 subrutinas

1740 '*** Resultante:                   '*** Subr.Pral.: Clculo para una f.n.
1750  X = X3 / D                                 '*** prof. f.n. relativa
1760  IF X < .2593 THEN EPSC = 100 * X / (1 - X): GOTO 1790
1770  IF X3 < H THEN EPSC = 35: GOTO 1790        '*** epsc = def. fibra sup.
1780  X = X3 / H: EPSC = 20 * X / (X - 3 / 7)
1790  DEPS = EPSC / X3: X4 = X3                  '*** deps = gradiente deform.

1800  IF X4 > H THEN X4 = H                      '*** Esfzos.sec.circular ext.
1810  FAC = X4 / 7 * .85 * FCD
1820  NC! = 0: MC = 0
1830  FOR I = 1 TO 7
1840    U = K(I) * X4                            '*** Prof. fibra
1850    B = 2 * SQR((H - U) * U)                 '*** Ancho fibra
1860    EPS = EPSC - U * DEPS                    '*** Deformacin fibra
1870    IF EPS > 20 THEN SGR = 1 ELSE S = 1 - EPS / 20: SGR = 1 - S * S
1880    SGR = SGR * B                            '*** Tensin y axil fibra
1890    NC! = NC! + SGR
1900    MC = MC + SGR * (H2 - U)
1910  NEXT I
1920  NC! = NC! * FAC
1930  MC = MC * FAC

1940  X4 = X3 - ESP: IF X4 > HI THEN X4 = HI     '*** Esfzos.sec.hueca inter.
1950  IF X4 <= 0 THEN 2090
1960    FAC = X4 / 7 * .85 * FCD
1970    NCI! = 0: MCI = 0
1980    FOR I = 1 TO 7
1990      UI = K(I) * X4: U = ESP + UI
2000      B = 2 * SQR((HI - UI) * UI)
2010      EPS = EPSC - U * DEPS
2020      IF EPS > 20 THEN SGR = 1 ELSE S = 1 - EPS / 20: SGR = 1 - S * S
2030      SGR = SGR * B
2040      NCI! = NCI! + SGR
2050      MCI = MCI + SGR * (H2 - U)
2060    NEXT I
2070    NC! = NC! - NCI! * FAC
2080    MC = MC - MCI * FAC

2090 NS! = 0: MS = 0: S = .21 * EPSC             '*** Esfzos armaduras Abar=1
2100 FOR I = 1 TO NB2
2110    SGR = S * (X3 + Y(I) - H2) / X3          '*** Tensin en cada capa
2120    IF SGR < -FYD THEN SGR = -FYD
2130    IF SGR > FYD THEN SGR = FYD
2140    SGR = SGR * N(I): NS! = NS! + SGR
2150    MS = MS + SGR * Y(I)
2160  NEXT I

2170  NF! = ND! - NC!: MF = MD - MC              '*** Esfzos dif. para acero
2180  ERRO= (NF! - MF * NS! / MS) / ND!          '*** Error de axil
2190  RETURN
