1010 '***** PROGRAMA PRED - Prtico Regular Edificacin -  Anlisis Lineal
1020 '***** Autores: F.Morn Cabr - A.Garca Meseguer - P.Jimnez Montoya
1030 '***** Ref: Hormign Armado, 13 Ed - Tomo 2 - Editorial G.Gili, Barna
1040 '***** Lenguaje: GW BASIC para compatibles IBM-PC/XT/AT/PS2 en MS-DOS

1050 DEFINT I-N: OPTION BASE 1
1060 OPEN "DATOS" FOR INPUT AS #1
1070 OPEN "RES" FOR OUTPUT AS #2

1080 'GOSUB 1220                     'Tarjeta.Grafica
1090 GOSUB 1300                      'Dat.Grales
1100 GOSUB 1420                      'Alturas
1110 GOSUB 1490                      'Luces
1120 GOSUB 1560                      'Barras.Tipo
1130 'GOSUB 1630                     'Escalas
1140 GOSUB 1680                      'Mat.Rigidez
1150 GOSUB 2090                      'Cargas
1160 'GOSUB 2430                     'Print.Matriz
1170 'GOSUB 2270                     'Croquis
1180 'GOSUB 2530                     'Okey
1190 GOSUB 2580                      'Sol.Sistema
1200 GOSUB 2870                      'Graba.Resul

1210 SCREEN 0: END


1220 'Tarjeta.Grafica:                '*** Tipo de monitor/tarjeta grfica:
1230   HERC% =  0                     '*** CGA = 0; Her = 1; EGA = 7; VGA = 10
1240   IF HERC% = 0 THEN NPIXX = 639: NPIXY = 199: NCARX = 8: NCARY = 8: REL = 2.6
1250   IF HERC% = 1 THEN NPIXX = 719: NPIXY = 347: NCARX = 9: NCARY = 14: REL = 1.5
1260   IF HERC% = 7 THEN NPIXX = 639: NPIXY = 349: NCARX = 8: NCARY = 14: REL = 1.4
1270   IF HERC% = 10 THEN NPIXX = 639: NPIXY = 479: NCARX = 8: NCARY = 16: REL = 1
1280   IF HERC% = 10 THEN NFP = 30 ELSE NFP = 25
1290   RETURN


1300 'Dat.Grales:                       '*** Lectura del ttulo, datos grales
1310   INPUT #1, TIT$                   '*** y dimensionamiento de las matrices
1320   ER$ = "TITULO": GOSUB 3620
1330   INPUT #1, NPI, NSO, NHI, E       '*** N.pisos, N.soportes, Nhipt, Young
1340   ER$ = "DATOS GRALES": GOSUB 3620
1350   NECP = NSO + 1                           '*** N. ecuac. por piso
1360   NEC = NECP * NPI: NSB = 2 * NECP         '*** N. ecuac, ancho semibanda
1370   NVA = NSO - 1                            '*** N. vanos
1380   DIM H(NPI), RL(NVA), AX(NSO)             '*** Alturas, luces, axiles
1390   DIM ITSOP(NPI, NSO), ITVIG(NPI, NVA)     '*** Tipos de soportes y vigas
1400   DIM R(NEC, NSB), F(NEC, NHI)             '*** Matrices de Rigidez y Cargas
1410   RETURN


1420 'Alturas:                        '*** Lect. alturas pisos empezando ltimo
1430   HTOT = 0
1440   FOR I = NPI TO 1 STEP -1
1450     INPUT #1, H(I)
1460     HTOT = HTOT + H(I)
1470   NEXT I: ER$ = "ALTURAS": GOSUB 3620
1480   RETURN


1490 'Luces:                         '*** Lect. luces vanos empezando izquierda
1500   RLTOT = 0
1510   FOR I = 1 TO NVA
1520     INPUT #1, RL(I)
1530     RLTOT = RLTOT + RL(I)
1540   NEXT I: ER$ = "LUCES": GOSUB 3620
1550   RETURN


1560 'Barras.Tipo:                 '*** Lectura de las secciones de barras tipo
1570   INPUT #1, NBT: DIM INER!(NBT)
1580   FOR I = 1 TO NBT
1590     INPUT #1, B, H
1600     IF B = 0 THEN INER!(I) = H ELSE INER!(I) = B * H * H * H / 1.2E+09
1610   NEXT I: ER$ = "BARRAS TIPO": GOSUB 3620
1620   RETURN


1630 'Escalas:                       '*** Clculo de las escalas del croquis
1640   CLS : SCREEN 2 + HERC%
1650   ESX = NPIXX / RLTOT: ESY = NPIXY / HTOT
1660   IF ESX > REL * ESY THEN ESX = REL * ESY ELSE ESY = ESX / REL
1670   RETURN


1680 'Mat.Rigidez:                '*** Lectura de datos barras y form.mat.rig.
1690   FOR IPIS = NPI TO 1 STEP -1            '*** Lee sop. empez. ltimo piso
1700     FOR ISOP = 1 TO NSO
1710       INPUT #1, ITIP
1720       IF ITIP >= 1 AND ITIP <= NBT THEN 1750
1730         ER$ = "SOPORTE " + STR$(ISOP) + " PISO "+ STR$(IPIS)
1740         GOSUB 3670: END
1750       ITSOP(IPIS, ISOP) = ITIP             '*** Almacena el tipo de sop.
1760       EIH = 2 * E * INER!(ITIP) / H(IPIS)
1770       EIH2 = 6 * E * INER!(ITIP) / H(IPIS) / H(IPIS)
1780       EIH3 = 12 * E * INER!(ITIP) / H(IPIS) / H(IPIS) / H(IPIS)
1790       IAC = NECP * (IPIS - 1) + ISOP           '*** Fila piso actual
1800       IIN = IAC - NECP                         '*** Fila piso inferior
1810       IF IIN <= 0 THEN 1890
1820         I = IIN: J = 1: R(I, J) = R(I, J) + 2 * EIH                ' D
1830         J = 1 + NECP - ISOP: R(I, J) = R(I, J) + EIH2              ' E
1840         J = 1 + NECP: R(I, J) = EIH                                ' F
1850         J = 1 + NECP - ISOP + NECP: R(I, J) = -EIH2                ' G
1860         I = IIN + NECP - ISOP: J = 1: R(I, J) = R(I, J) + EIH3     ' H
1870         J = 1 + ISOP: R(I, J) = R(I, J) + EIH2                     ' I
1880         J = 1 + NECP: R(I, J) = R(I, J) - EIH3                     ' J
1890       I = IAC: J = 1: R(I, J) = R(I, J) + 2 * EIH                  ' K
1900       J = 1 + NECP - ISOP: R(I, J) = R(I, J) - EIH2                ' L
1910       I = IAC + NECP - ISOP: J = 1: R(I, J) = R(I, J) + EIH3       ' M
1920     NEXT ISOP
1930   NEXT IPIS: ER$ = "DEF. SOPORTES": GOSUB 3620

1940   FOR IPIS = NPI TO 1 STEP -1           '*** Lee vigas empez. ltimo piso
1950     FOR IVIG = 1 TO NVA
1960      INPUT #1, ITIP
1970      IF ITIP >= 1 AND ITIP <= NBT THEN 2000
1980        ER$ = "VIGA " + STR$(IVIG) + " PISO "+ STR$(IPIS)
1990        GOSUB 3670: END
2000      ITVIG(IPIS, IVIG) = ITIP              '*** Almacena el tipo de viga
2010      EIL = 2 * E * INER!(ITIP) / RL(IVIG)
2020      IAC = NECP * (IPIS - 1) + IVIG        '*** Fila viga
2030      R(IAC, 1) = R(IAC, 1) + 2 * EIL                               ' D'
2040      R(IAC, 2) = R(IAC, 2) + EIL                                   ' E'
2050      R(IAC + 1, 1) = R(IAC + 1, 1) + 2 * EIL                       ' F'
2060     NEXT IVIG
2070   NEXT IPIS: ER$ = "DEF. VIGAS": GOSUB 3620
2080   RETURN


2090 'Cargas:
2100  FOR IH = 1 TO NHI                       '*** Lee cargas por hiptesis
2110    FOR IPIS = NPI TO 1 STEP -1              '*** Empieza por ltimo piso
2120      I = NECP * (IPIS - 1) + 1              '*** 1a. ecuacin del piso
2130      INPUT #1, MVI!, PVI                    '*** Mom. y carga volad. izq.
2140      F(I, IH) = F(I, IH) - MVI!
2150      FOR IVIG = 1 TO NVA
2160        INPUT #1, P                          '*** Carga en viga
2170        MEM! = P * RL(IVIG) * RL(IVIG) / 12
2180        F(I, IH) = F(I, IH) + MEM!: I = I + 1
2190        F(I, IH) = F(I, IH) - MEM!
2200      NEXT IVIG
2210      INPUT #1, PVD, MVD!, FH               '*** Mom. y carga volad. dch.
2220      F(I, IH) = F(I, IH) + MVD!: I = I + 1
2230      F(I, IH) = FH
2240    NEXT IPIS: ER$ = "CARGAS": GOSUB 3620
2250  NEXT IH
2260  RETURN


2270 'Croquis:                        '*** Dibujo del croquis de la estructura
2280  X = 0
2290  FOR ISOP = 1 TO NSO
2300    X1 = X * ESX: Y1 = NPIXY
2310    X2 = X1: Y2 = NPIXY - HTOT * ESY
2320    LINE (X1, Y1)-(X2, Y2)
2330    IF ISOP < NSO THEN X = X + RL(ISOP)
2340  NEXT ISOP
2350  Y = H(1)
2360  FOR IPIS = 1 TO NPI
2370    X1 = 0: Y1 = NPIXY - Y * ESY
2380    X2 = RLTOT * ESX: Y2 = Y1
2390    LINE (X1, Y1)-(X2, Y2)
2400    IF IPIS < NPI THEN Y = Y + H(IPIS + 1)
2410  NEXT IPIS
2420  RETURN


2430 'Print.Matriz:                   '*** Impresin por filas de las matrices
2440  FOR I = 1 TO NEC                '*** de rigidez y de terminos independtes
2450    FOR J = 1 TO NSB              '*** para pruebas del programa
2460      PRINT #2, R(I, J);
2470    NEXT J
2480    FOR J = 1 TO NHI
2490      PRINT #2, F(I, J);
2500    NEXT J: PRINT #2, : IF (I \ 6) * 6 = I THEN PRINT #2,
2510  NEXT I
2520  RETURN


2530 'Okey:                        '*** Conformidad del usuario con el croquis
2540  LOCATE 1, 59: PRINT "Desea seguir? (s/n)": K$ = INKEY$
2550  WHILE K$ = "": K$ = INKEY$: WEND
2560  IF K$ = "n" OR K$ = "N" THEN ER$ = "CROQUIS": GOSUB 3670: END
2570  RETURN


2580 'Sol.Sistema:                '*** Resolucin del sistema de ecuaciones
2590  CLS : PRINT "SOLUCION SISTEMA. PISOS TRATADOS:"
2600  FOR I = 1 TO NEC - 1        '*** Triangulacin. Fila i se resta de sgtes
2610    IF ((I + 1) \ NECP) * NECP = I + 1 THEN PRINT USING "####"; (I + 1) \ NECP;
2620    FOR J = 2 TO NSB
2630      NFI = I + J - 1              '*** Fila a la que se resta la i
2640      IF NFI > NEC OR R(I, J) = 0 THEN 2740
2650        FAC = R(I, J) / R(I, 1)    '*** Factor por que se mult. fila i
2660        K = 1
2670        FOR L = J TO NSB
2680          R(NFI, K) = R(NFI, K) - FAC * R(I, L)
2690          K = K + 1
2700        NEXT L
2710        FOR K = 1 TO NHI
2720          F(NFI, K) = F(NFI, K) - FAC * F(I, K)
2730        NEXT K
2740    NEXT J
2750  NEXT I

2760  FOR I = NEC TO 1 STEP -1        '*** Sustitucin hacia atrs
2770    FOR K = 1 TO NHI
2780      SUM = 0
2790      FOR J = 2 TO NSB
2800        NFI = I + J - 1
2810        IF NFI <= NEC THEN SUM = SUM + R(I, J) * F(NFI, K)
2820      NEXT J
2830      F(I, K) = (F(I, K) - SUM) / R(I, 1)
2840    NEXT K
2850  NEXT I
2860  RETURN


2870 'Graba.Resul:                      '*** Clculo y grabacin de resultados
2880  PRINT : PRINT "GRABANDO RESULTADOS"
2890  CLOSE #1: OPEN "DATOS" FOR INPUT AS #1    '*** Lee datos para cargas
2900  INPUT #1, TIT$: GOSUB 3620
2910  INPUT #1, N, N, N, A: GOSUB 3620
2920  FOR I = 1 TO NPI: INPUT #1, A: NEXT I: GOSUB 3620
2930  FOR I = 1 TO NVA: INPUT #1, A: NEXT I: GOSUB 3620
2940  INPUT #1, N: FOR I = 1 TO N: INPUT #1, A, A: NEXT I: GOSUB 3620
2950  FOR I = 1 TO NPI * NSO: INPUT #1, N: NEXT I: GOSUB 3620
2960  FOR I = 1 TO NPI * NVA: INPUT #1, N: NEXT I: GOSUB 3620

2970  B$ = "   Piso Despl.x"
2980  C$ = "###### ##.#####"
2990  A$ = "       ESFUERZOS EN SOPORTES        "
3000  D$ = "PI SOP   AXIL   M.SUP   M.INF   CTE "
3010  A1$ = "           ESFUERZOS EN VIGAS"
3020  D1$ = "VAN  M.IZQ   M.CEN   M.DCH  CT.IZQ CT.DCH"

3030  FOR IH = 1 TO NHI
3040    PRINT #2, : PRINT #2, TIT$
3050    PRINT #2, : PRINT #2, TAB(20); LINT$
3060    PRINT #2, : PRINT #2, TAB(26); "DESPLAZAMIENTOS DE PISOS"
3070    PRINT #2, : PRINT #2, B$ + B$ + B$ + B$ + B$: PRINT #2,
3080    FOR IPIS = 1 TO NPI
3090      PRINT #2, USING C$; IPIS, F(IPIS * NECP, IH);
3100      IF (IPIS \ 5) * 5 = IPIS THEN PRINT #2,
3110    NEXT IPIS

3120    PRINT #2, : PRINT #2, : A2$ = SPACE$(36) + ""
3130    PRINT #2, A$; A1$: PRINT #2, A2$
3140    PRINT #2, D$; D1$: PRINT #2, A2$
3150    FOR I = 1 TO NSO: AX(I) = 0: NEXT I       '*** Puesta a 0 de axiles
3160    FOR IPIS = NPI TO 1 STEP -1
3170       I = (IPIS - 1) * NECP + 1              '*** 1a. ecuacin del piso
3180       DX = -F(IPIS * NECP, IH)               '*** Diferencia desplaz. piso
3190       IF IPIS > 1 THEN DX = DX + F((IPIS - 1) * NECP, IH)
3200       INPUT #1, MVI!, PVI                    '*** Mom. y carga vol. izq.
3210       AX(1) = AX(1) + PVI
3220       FOR ISOP = 1 TO NSO
3230         EI = E * INER!(ITSOP(IPIS, ISOP))
3240         EIH = 2 * EI / H(IPIS)
3250         EIH2 = 6 * EI / H(IPIS) / H(IPIS)
3260         IF ISOP >= NSO THEN 3400
3270           IVIG = ISOP
3280           INPUT #1, P                      '*** Carga en la viga
3290           EIL = 2 * E * INER!(ITVIG(IPIS, IVIG)) / RL(IVIG)
3300           MEM! = P * RL(IVIG) * RL(IVIG) / 12               '* M. empotr.
3310           VEM = P * RL(IVIG) / 2                            '* Cte.empot.
3320           MD! = EIL * (2 * F(I, IH) + F(I + 1, IH)) - MEM!  '* M. dorsal
3330           MF! = -EIL * (F(I, IH) + 2 * F(I + 1, IH)) - MEM! '* M. front.
3340           MC! = (MD! + MF!) / 2 + 1.5 * MEM!                '* M. centro
3350           VD = (MD! - MF!) / RL(IVIG) - VEM                 '* Cte.dors.
3360           VF = (MD! - MF!) / RL(IVIG) + VEM                 '* Cte.fron.
3370           AX(ISOP) = AX(ISOP) - VD                          '* Axil s.iz.
3380           AX(ISOP + 1) = AX(ISOP + 1) + VF                  '* Axil s.dc.
3390         GOTO 3420
3400           INPUT #1, PVD, MVD!, FH         '*** Carga, mom y fza vol. dch.
3410           AX(NSO) = AX(NSO) + PVD
3420         MI! = F(I, IH): MS! = 2 * MI!
3430         IF IPIS = 1 THEN 3460
3440           MI! = MI! + 2 * F(I - NECP, IH)
3450           MS! = MS! + F(I - NECP, IH)
3460         I = I + 1
3470         MI! = EIH * MI! + EIH2 * DX                         '* M.inferior
3480         MS! = -EIH * MS! - EIH2 * DX                        '* M.superior
3490         VS = (MI! - MS!) / H(IPIS)                          '* Cte.sopor.
3500         PRINT #2, USING "## ##"; IPIS, ISOP;
3510         PRINT #2, USING "####.###"; AX(ISOP), MS!, MI!;
3520         PRINT #2, USING "###.###"; VS;
3530         IF ISOP >= NSO THEN 3570
3540           PRINT #2, USING "##"; IVIG;
3550           PRINT #2, USING "####.###"; MD!, MC!, MF!, VD;
3560           PRINT #2, USING "###.###"; VF: GOTO 3580
3570           PRINT #2,
3580       NEXT ISOP: IF IPIS > 1 THEN PRINT #2, A2$ ELSE PRINT #2,
3590     NEXT IPIS: GOSUB 3620: PRINT #2, CHR$(12)
3600   NEXT IH
3610 RETURN


3620 'Fin.Grupo:                       '*** Chequeo de final de grupo de datos
3630  INPUT #1, LINB$: IF LINB$ <> "" THEN GOSUB 3670: END  '*** L. en blanco
3640  INPUT #1, LINT$                                       '*** L.con ttulo
3650  INPUT #1, LINB$: IF LINB$ <> "" THEN GOSUB 3670: END  '*** L. en blanco
3660  RETURN


3670 'Mensaje:                         '*** Impresin de mensaje de error
3680  LOCATE 24, 30: PRINT "ERROR EN "; ER$
3690  PRINT "PULSE CUALQUIER TECLA PARA TERMINAR"
3700  WHILE INKEY$ = "": WEND
3710  SCREEN 0
3720  RETURN
